(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15022,        418]
NotebookOptionsPosition[      8328,        247]
NotebookOutlinePosition[     14128,        384]
CellTagsIndexPosition[     14043,        379]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["conventions", "Title",
 CellChangeTimes->{{3.568058114413023*^9, 3.5680581181726294`*^9}, {
  3.56805848279207*^9, 3.568058486395676*^9}},
 FontSize->18,
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Package", "Subsection",
 CellChangeTimes->{{3.5555351029580054`*^9, 3.5555351043152075`*^9}, {
  3.5555362843012805`*^9, 3.555536288981289*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", "version"}], "Input",
 CellChangeTimes->{{3.5540063044955845`*^9, 3.554006320946525*^9}, {
   3.5661507405731773`*^9, 3.5661507462359877`*^9}, 3.566151372483487*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Wed 27 Nov 2013 08:04:23\"\>", ",", 
   "52831"}], "}"}]], "Output",
 CellChangeTimes->{
  3.566150812364504*^9, 3.5694061385130596`*^9, 3.572100063474079*^9, 
   3.572100214191946*^9, 3.5721003508573895`*^9, 3.572544481185506*^9, 
   3.5725471172352796`*^9, 3.5749574963441877`*^9, 3.5772849086173353`*^9, 
   3.577345071521171*^9, 3.5817466618273907`*^9, 3.590810807477186*^9, 
   3.5908245042258787`*^9, 3.5909099943255444`*^9, 3.590947473737548*^9, 
   3.591864230729383*^9, {3.592462981892049*^9, 3.592462996322074*^9}, 
   3.5929705654743423`*^9, 3.602224677723527*^9, 3.6023303204825087`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Indices", "Subsection",
 CellChangeTimes->{{3.568059612483654*^9, 3.568059623434873*^9}}],

Cell["\<\
Indices run through:  i\[Element]{1,dim} - for covariant components and i\
\[Element]{-dim,-1} - for contravariant ones. This is the (reverse!) \
Parker-Christensen index convention (+co,-contra).  Values 1 and -1 refer to \
time components.\
\>", "Text",
 CellChangeTimes->{{3.5601536020500917`*^9, 3.5601538379537067`*^9}, 
   3.568060465742753*^9, 3.5909474433278084`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Metric signature", "Subsection",
 CellChangeTimes->{{3.5680596332004905`*^9, 3.568059635852495*^9}}],

Cell["Metric signature: {-,+,+,+}", "Text",
 CellChangeTimes->{{3.5680586263591223`*^9, 3.568058655858774*^9}, 
   3.568059252232221*^9, 3.5680596581605344`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Affine connection", "Subsection",
 CellChangeTimes->{{3.568059643902109*^9, 3.568059654276128*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox["\[CapitalGamma]", 
    RowBox[{"k", " ", "i", " ", "j", " "}]], "\[LongEqual]", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[PartialD]", 
         SubscriptBox["g", 
          RowBox[{"i", " ", "j"}]]}], 
        RowBox[{"\[PartialD]", 
         SuperscriptBox["x", "k"]}],
        MultilineFunction->None]}], "+", 
      FractionBox[
       RowBox[{"\[PartialD]", 
        SubscriptBox["g", 
         RowBox[{" ", 
          RowBox[{"k", " ", "j"}]}]]}], 
       RowBox[{"\[PartialD]", 
        SuperscriptBox["x", "i"]}],
       MultilineFunction->None], "+", 
      FractionBox[
       RowBox[{"\[PartialD]", 
        SubscriptBox["g", 
         RowBox[{"i", " ", "k"}]]}], 
       RowBox[{"\[PartialD]", 
        SuperscriptBox["x", "j"]}],
       MultilineFunction->None]}], ")"}]}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.5688260485241823`*^9, 3.568826076682232*^9}, {
  3.5688261101598907`*^9, 3.568826133419532*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox[
    SuperscriptBox["\[CapitalGamma]", "k"], 
    RowBox[{"i", " ", "j"}]], "\[LongEqual]", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{
     SuperscriptBox["g", 
      RowBox[{"k", " ", "s", " "}]], "(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[PartialD]", 
         SubscriptBox["g", 
          RowBox[{"i", " ", "j"}]]}], 
        RowBox[{"\[PartialD]", 
         SuperscriptBox["x", "s"]}],
        MultilineFunction->None]}], "+", 
      FractionBox[
       RowBox[{"\[PartialD]", 
        SubscriptBox["g", 
         RowBox[{"s", " ", "j"}]]}], 
       RowBox[{"\[PartialD]", 
        SuperscriptBox["x", "i"]}],
       MultilineFunction->None], "+", 
      FractionBox[
       RowBox[{"\[PartialD]", 
        SubscriptBox["g", 
         RowBox[{"i", " ", "s"}]]}], 
       RowBox[{"\[PartialD]", 
        SuperscriptBox["x", "j"]}],
       MultilineFunction->None]}], ")"}]}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.568058843121503*^9, 3.5680588614047346`*^9}, {
  3.5688261554467697`*^9, 3.56882618410402*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\[CapitalGamma]"}]], "Input",
 CellChangeTimes->{{3.555528711768344*^9, 3.5555287155279503`*^9}, 
   3.555529399495552*^9}],

Cell[BoxData[
 StyleBox["\<\"Christoffel symbol: \[CapitalGamma][s,m,n] = \
\!\(\*SubscriptBox[\(\[CapitalGamma]\), \(smn\)]\),  \[CapitalGamma][-s,m,n] \
= \!\(\*SubscriptBox[SuperscriptBox[\(\[CapitalGamma]\), \(s\)], \
\(mn\)]\)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.602330320742509*^9},
 CellTags->"Info3602333920-6726278"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Riemann tensor", "Subsection",
 CellChangeTimes->{{3.568059665258547*^9, 3.56805967285576*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox["R", 
    RowBox[{"i", " ", "j", " ", "m", " ", "n"}]], "\[LongEqual]", 
   RowBox[{
    RowBox[{
     SubscriptBox[
      SuperscriptBox["\[CapitalGamma]", "p"], 
      RowBox[{"i", " ", "n"}]], " ", 
     SubscriptBox["\[CapitalGamma]", 
      RowBox[{"j", " ", "m", " ", "p"}]]}], "-", 
    RowBox[{
     SubscriptBox[
      SuperscriptBox["\[CapitalGamma]", "p"], 
      RowBox[{"i", " ", "m"}]], 
     SubscriptBox["\[CapitalGamma]", 
      RowBox[{"p", " ", "j", " ", "n"}]]}], " ", "+", 
    FractionBox[
     RowBox[{"\[PartialD]", 
      SubscriptBox["\[CapitalGamma]", 
       RowBox[{"j", " ", "i", " ", "m"}]]}], 
     RowBox[{"\[PartialD]", 
      SuperscriptBox["x", "n"]}],
     MultilineFunction->None], " ", "-", 
    FractionBox[
     RowBox[{"\[PartialD]", 
      SubscriptBox["\[CapitalGamma]", 
       RowBox[{"j", " ", "i", " ", "n"}]]}], 
     RowBox[{"\[PartialD]", 
      SuperscriptBox["x", "m"]}],
     MultilineFunction->None]}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.568059306114716*^9, 3.568059317799136*^9}, 
   3.5680595005222573`*^9, {3.568059723321849*^9, 3.5680597314962635`*^9}, {
   3.568059767766327*^9, 3.5680599905971184`*^9}, {3.5688255351584806`*^9, 
   3.5688256063570056`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "tRiemannR"}]], "Input",
 CellChangeTimes->{{3.5688443470959935`*^9, 3.568844352524803*^9}}],

Cell[BoxData[
 StyleBox["\<\"Riemann tensor: \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,j,m,n] \
= \!\(\*SubscriptBox[\(R\), \(ijmn\)]\), \\n\t\!\(\*\\nStyleBox[\\\"tRiemannR\
\\\",\\nFontSlant->\\\"Italic\\\"]\)[-i, j,m,n] = \
\!\(\*SubscriptBox[SuperscriptBox[\(R\), \(i\)], \(jmn\)]\),   \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,-j, \
m,n] = \!\(\*SubscriptBox[SuperscriptBox[SubscriptBox[\(R\), \(i\)], \(j\)], \
\(mn\)]\), ...\\n\t\
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[-i,-j,m,n]\
 = \!\(\*SubscriptBox[SuperscriptBox[\(R\), \(ij\)], \(mn\)]\),  \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,-j,-m,n]\
 = \!\(\*SubscriptBox[SuperscriptBox[SubscriptBox[\(R\), \(i\)], \(jm\)], \(n\
\)]\), ...\\n\t(...)\\n\t\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\
\"Italic\\\"]\)[-i,-j,-m,-n] = \!\(\*SuperscriptBox[\(R\), \(ijmn\)]\) \"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.602330320932509*^9},
 CellTags->"Info3602333920-6726278"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {{3.568976128298403*^9, 3.568976151589244*^9}, {
        3.5689765242894983`*^9, 3.5689765261927013`*^9}}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {{3.56897650241826*^9, 3.5689765210758924`*^9}, {
           3.568976571417181*^9, 3.568976573569985*^9}}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {{3.568976536114319*^9, 
           3.5689765583287582`*^9}}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {{3.568976333111162*^9, 3.5689763428923798`*^9}, {
        3.5689812244072604`*^9, 3.568981227090465*^9}}, FontFamily -> 
       "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {{3.5689812314740725`*^9, 
           3.5689812390088863`*^9}}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", 
          CellChangeTimes -> {{3.568980449396245*^9, 
           3.5689804565254574`*^9}}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3602333920-6726278"->{
  Cell[5280, 167, 348, 6, 42, "Print",
   CellTags->"Info3602333920-6726278"],
  Cell[7214, 225, 1074, 17, 125, "Print",
   CellTags->"Info3602333920-6726278"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3602333920-6726278", 13858, 371}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 187, 4, 69, "Title"],
Cell[CellGroupData[{
Cell[792, 30, 150, 2, 31, "Subsection"],
Cell[CellGroupData[{
Cell[967, 36, 272, 5, 65, "Input"],
Cell[1242, 43, 668, 11, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1959, 60, 95, 1, 25, "Subsection"],
Cell[2057, 63, 385, 7, 45, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2479, 75, 106, 1, 31, "Subsection"],
Cell[2588, 78, 161, 2, 28, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2786, 85, 105, 1, 31, "Subsection"],
Cell[2894, 88, 1075, 33, 46, "Text"],
Cell[3972, 123, 1128, 35, 46, "Text"],
Cell[CellGroupData[{
Cell[5125, 162, 152, 3, 44, "Input"],
Cell[5280, 167, 348, 6, 42, "Print",
 CellTags->"Info3602333920-6726278"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5677, 179, 101, 1, 31, "Subsection"],
Cell[5781, 182, 1285, 35, 44, "Text"],
Cell[CellGroupData[{
Cell[7091, 221, 120, 2, 44, "Input"],
Cell[7214, 225, 1074, 17, 125, "Print",
 CellTags->"Info3602333920-6726278"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
