(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     74327,       2034]
NotebookOptionsPosition[     65633,       1789]
NotebookOutlinePosition[     71125,       1920]
CellTagsIndexPosition[     70997,       1914]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["covariant derivative", "Title",
 FontSize->18,
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Initial section", "Section"],

Cell[CellGroupData[{

Cell["Package", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\n", "version"}], "Input"],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.6023308303692336`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Wed 27 Nov 2013 08:04:23\"\>", ",", 
   "52831"}], "}"}]], "Output",
 CellChangeTimes->{{3.572102354518825*^9, 3.57210236866805*^9}, 
   3.572102399400104*^9, 3.572546738360609*^9, 3.5749573895932007`*^9, 
   3.5772846090344095`*^9, 3.5773449299197226`*^9, 3.586989740945828*^9, 
   3.5885729737528143`*^9, 3.590901854915184*^9, 3.590909878932142*^9, 
   3.590926837536134*^9, 3.5909268819338117`*^9, 3.5909269188122764`*^9, 
   3.5911984043060384`*^9, 3.5912252436528597`*^9, 3.5912628043070974`*^9, 
   3.591266971729617*^9, 3.591552281593299*^9, 3.591606113546083*^9, 
   3.591776830693915*^9, 3.5917999326863165`*^9, 3.5918860031411114`*^9, 
   3.592462731714409*^9, 3.5929707607685127`*^9, 3.602224833871458*^9, 
   3.602330830379234*^9}]
}, Open  ]],

Cell[TextData[{
 ButtonBox["Download ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
 StyleBox[ButtonBox["ccgrg",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.572524842630431*^9, 3.5725248687292767`*^9}},
 TextAlignment->Right]
}, Closed]],

Cell[CellGroupData[{

Cell["Coordinates and the metric tensor", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData["Friedman"], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "0", "0", "0"},
         {"0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0", "0"},
         {"0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0"},
         {"0", "0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.5721023567184286`*^9, 3.572102370430853*^9}, 
   3.5721024021145086`*^9, 3.5725467410587635`*^9, 3.5749573919800043`*^9, 
   3.5772846116084137`*^9, 3.577344932524927*^9, 3.586989743488632*^9, 
   3.588572976436019*^9, 3.59090185812879*^9, 3.5909098818181467`*^9, 
   3.5909268382537346`*^9, 3.590926884445416*^9, 3.590926921308281*^9, 
   3.5911984078628445`*^9, 3.591225247038066*^9, 3.591262808238304*^9, 
   3.591266975239623*^9, 3.591552285243705*^9, 3.5916061184600916`*^9, 
   3.5917768343599215`*^9, 3.5917999368863225`*^9, 3.591886006838318*^9, 
   3.5924627349592147`*^9, 3.592970764415721*^9, 3.6022248362175922`*^9, 
   3.6023308308092346`*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["covariantD", "Section"],

Cell["Syntax:  covariantD[T][indexes]", "Text"],

Cell[TextData[{
 StyleBox["covariantD",
  FontSlant->"Italic"],
 " is the n-th order covariant derivative of the tensor T.",
 StyleBox[" covariantD",
  FontSlant->"Italic"],
 " employs the coordinate system X and the metric tensor g declared in the \
procedure ",
 StyleBox["open",
  FontSlant->"Italic"],
 "[X,g].  "
}], "Text"],

Cell["\<\
Internal argument  contains the tensor name T (for tensor definition see \
tensorExt). The external argument sequence comprise indexes of the resulting \
tensor. The number of indexes is not fixed. First n  (1 to tensorrank)  are \
indexes of  the original tensor T. Next ones refer to differentiation (each \
of the next indexes rise the differentiation order by one). The list \
structure within the index sequence is allowed but ambivalent.\
\>", "Text"],

Cell[CellGroupData[{

Cell["covariantD: usage", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "covariantD"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"\!\(\*\\nStyleBox[\\\"covariantD\\\",\\nFontSlant->\\\"Italic\\\
\"]\)[T][{i,j},{k,l,m}] = \!\(\*\\nStyleBox[\\\"covariantD\\\",\\nFontSlant->\
\\\"Italic\\\"]\)[T][i,j,k,l,m] =\!\(\*SubscriptBox[\(T\), \(ij; \
klm\)]\)\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.602330831089235*^9},
 CellTags->"Info3602334430-3770194"]
}, Open  ]],

Cell["short name:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "\[EmptyDownTriangle]"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"\[EmptyDownTriangle] is short name for covariantD\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.602330831259235*^9},
 CellTags->"Info3602334431-3770194"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples", "Section"],

Cell[CellGroupData[{

Cell["Example: derivatives of scalar quantities", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sRicciR", "[", "]"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"K", " ", 
      RowBox[{"a", "[", "\[Eta]", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]], "Output",
 CellChangeTimes->{{3.5721023585592318`*^9, 3.5721023717880554`*^9}, 
   3.572102403612111*^9, 3.572546743118881*^9, 3.5749573934464073`*^9, 
   3.577284613028016*^9, 3.57734493411613*^9, 3.586989744861435*^9, 
   3.588572978136422*^9, 3.590901860063193*^9, 3.59090988356535*^9, 
   3.590926839610937*^9, 3.5909268858650184`*^9, 3.590926922681083*^9, 
   3.5911984105460496`*^9, 3.5912252503920717`*^9, 3.591262810437908*^9, 
   3.591266977720028*^9, 3.5915522884417105`*^9, 3.5916061207064953`*^9, 
   3.5917768374487267`*^9, 3.591799940116327*^9, 3.591886009646323*^9, 
   3.5924627375644197`*^9, 3.592970767944923*^9, 3.6022248380506973`*^9, 
   3.6023308313592353`*^9}]
}, Open  ]],

Cell["First derivative:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"covariantD", "[", "sRicciR", "]"}], "[", "1", "]"}], "\n", 
 RowBox[{
  RowBox[{"partialD", "[", "sRicciR", "]"}], "[", "1", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"18", " ", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"K", " ", 
        RowBox[{"a", "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}], "+", 
  FractionBox[
   RowBox[{"6", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"K", " ", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["a", 
        TagBox[
         RowBox[{"(", "3", ")"}],
         Derivative],
        MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}]], "Output",
 CellChangeTimes->{{3.572102358730832*^9, 3.5721023719284554`*^9}, 
   3.5721024037681117`*^9, 3.5725467433138924`*^9, 3.5749573935868073`*^9, 
   3.5772846131684165`*^9, 3.5773449344437304`*^9, 3.586989745001835*^9, 
   3.588572978308022*^9, 3.590901860234793*^9, 3.59090988375255*^9, 
   3.5909268397357373`*^9, 3.590926886021019*^9, 3.590926922821483*^9, 
   3.59119841092045*^9, 3.591225250563672*^9, 3.591262810781109*^9, 
   3.591266978094428*^9, 3.591552288660111*^9, 3.591606121018496*^9, 
   3.591776837620327*^9, 3.5917999405363274`*^9, 3.5918860099739237`*^9, 
   3.59246273789202*^9, 3.5929707681099324`*^9, 3.602224838210706*^9, 
   3.6023308313892355`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"18", " ", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"K", " ", 
        RowBox[{"a", "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}], "+", 
  FractionBox[
   RowBox[{"6", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"K", " ", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["a", 
        TagBox[
         RowBox[{"(", "3", ")"}],
         Derivative],
        MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}]], "Output",
 CellChangeTimes->{{3.572102358730832*^9, 3.5721023719284554`*^9}, 
   3.5721024037681117`*^9, 3.5725467433138924`*^9, 3.5749573935868073`*^9, 
   3.5772846131684165`*^9, 3.5773449344437304`*^9, 3.586989745001835*^9, 
   3.588572978308022*^9, 3.590901860234793*^9, 3.59090988375255*^9, 
   3.5909268397357373`*^9, 3.590926886021019*^9, 3.590926922821483*^9, 
   3.59119841092045*^9, 3.591225250563672*^9, 3.591262810781109*^9, 
   3.591266978094428*^9, 3.591552288660111*^9, 3.591606121018496*^9, 
   3.591776837620327*^9, 3.5917999405363274`*^9, 3.5918860099739237`*^9, 
   3.59246273789202*^9, 3.5929707681099324`*^9, 3.602224838210706*^9, 
   3.6023308313892355`*^9}]
}, Open  ]],

Cell["Second derivative:", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"covariantD", "[", "sRicciR", "]"}], "[", 
    RowBox[{"1", ",", "1"}], "]"}], ";"}], "\n"}], "\n", 
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"Expand", "[", "%", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox["a", "\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}], ",", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}]}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{
  3.57728465521049*^9, {3.5772846966597633`*^9, 3.577284715754197*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"12", " ", "K", " ", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}], "-", 
  FractionBox[
   RowBox[{"18", " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "+", 
  RowBox[{
   SuperscriptBox[
    RowBox[{
     SuperscriptBox["a", "\[Prime]",
      MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"48", " ", "K"}], 
      SuperscriptBox[
       RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "+", 
     FractionBox[
      RowBox[{"90", " ", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
      SuperscriptBox[
       RowBox[{"a", "[", "\[Eta]", "]"}], "5"]]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{"42", " ", 
    RowBox[{
     SuperscriptBox["a", "\[Prime]",
      MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
    RowBox[{
     SuperscriptBox["a", 
      TagBox[
       RowBox[{"(", "3", ")"}],
       Derivative],
      MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "+", 
  FractionBox[
   RowBox[{"6", " ", 
    RowBox[{
     SuperscriptBox["a", 
      TagBox[
       RowBox[{"(", "4", ")"}],
       Derivative],
      MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}]], "Output",
 CellChangeTimes->{{3.5721023592924337`*^9, 3.5721023720688562`*^9}, 
   3.572102403955312*^9, 3.5725467435399055`*^9, 3.574957393774008*^9, 
   3.577284613340017*^9, 3.577284657831295*^9, {3.5772846990153675`*^9, 
   3.5772847166121984`*^9}, 3.5773449346153307`*^9, 3.5869897452358356`*^9, 
   3.5885729785264225`*^9, 3.5909018609055943`*^9, 3.5909098839397507`*^9, 
   3.5909268398761377`*^9, 3.5909268861926193`*^9, 3.590926922993084*^9, 
   3.5911984111076508`*^9, 3.5912252507820725`*^9, 3.5912628109683094`*^9, 
   3.591266978266029*^9, 3.591552289050112*^9, 3.5916061211900964`*^9, 
   3.5917768379479275`*^9, 3.5917999408263283`*^9, 3.591886010161124*^9, 
   3.5924627380948205`*^9, 3.5929707683059435`*^9, 3.602224838402717*^9, 
   3.602330831419235*^9}]
}, Open  ]],

Cell[TextData[{
 "See ",
 ButtonBox["more>>",
  BaseStyle->"Hyperlink",
  ButtonData->{
    FrontEnd`FileName[{
      ParentDirectory[
       ParentDirectory[
        ParentDirectory[
         ParentDirectory[
          ParentDirectory[
           ParentDirectory[
            ParentDirectory[
             ParentDirectory[
              ParentDirectory[]]]]]]]]], "Nauka", "Research", "1_Nauka_L", 
      "Problem2", "techniki", "ccgrg", "opisy", "opis38", "_files"}, 
     "scalarfunctions.nb", CharacterEncoding -> "WindowsEastEurope"], None}],
 " examples."
}], "Text",
 CellChangeTimes->{3.572107242628147*^9},
 TextAlignment->Right]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example: derivatives of tensors", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"covariantD", "[", "tRicciR", "]"}], "[", 
    RowBox[{"1", ",", "1", ",", "1"}], "]"}], "              ", "//", 
   "Simplify"}], "//", "Timing"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"covariantD", "[", "tRicciR", "]"}], "[", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "]"}], "     ", "//", 
   "Simplify"}], "//", "Timing"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0312002000000000008`4.514757291228131", ",", 
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{
           SuperscriptBox["a", "\[Prime]",
            MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], "-", 
        RowBox[{"5", " ", 
         RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
         RowBox[{
          SuperscriptBox["a", 
           TagBox[
            RowBox[{"(", "3", ")"}],
            Derivative],
           MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.572102359479634*^9, 3.572102372224856*^9}, 
   3.5721024041737127`*^9, 3.5725467438889256`*^9, 3.574957393976808*^9, 
   3.577284613511617*^9, 3.5773449348181314`*^9, 3.586989745407436*^9, 
   3.588572978791623*^9, 3.5909018611863947`*^9, 3.590909884111351*^9, 
   3.5909268401413383`*^9, 3.590926886364219*^9, 3.5909269231646843`*^9, 
   3.591198411294851*^9, 3.591225251031673*^9, 3.5912628112335095`*^9, 
   3.5912669784376287`*^9, 3.591552289518112*^9, 3.591606121642497*^9, 
   3.591776838166328*^9, 3.5917999410363283`*^9, 3.5918860103951244`*^9, 
   3.592462738297621*^9, 3.5929707685379567`*^9, 3.6022248386777325`*^9, 
   3.602330831499235*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.046800300000000003`4.690848550283811", ",", 
   FractionBox[
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"24", " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "4"]}], "-", 
       RowBox[{"37", " ", 
        RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{"9", " ", 
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
        RowBox[{
         SuperscriptBox["a", 
          TagBox[
           RowBox[{"(", "3", ")"}],
           Derivative],
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"5", " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["a", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "-", 
          RowBox[{
           RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
           RowBox[{
            SuperscriptBox["a", 
             TagBox[
              RowBox[{"(", "4", ")"}],
              Derivative],
             MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}]}], 
      ")"}]}], 
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}], "}"}]], "Output",
 CellChangeTimes->{{3.572102359479634*^9, 3.572102372224856*^9}, 
   3.5721024041737127`*^9, 3.5725467438889256`*^9, 3.574957393976808*^9, 
   3.577284613511617*^9, 3.5773449348181314`*^9, 3.586989745407436*^9, 
   3.588572978791623*^9, 3.5909018611863947`*^9, 3.590909884111351*^9, 
   3.5909268401413383`*^9, 3.590926886364219*^9, 3.5909269231646843`*^9, 
   3.591198411294851*^9, 3.591225251031673*^9, 3.5912628112335095`*^9, 
   3.5912669784376287`*^9, 3.591552289518112*^9, 3.591606121642497*^9, 
   3.591776838166328*^9, 3.5917999410363283`*^9, 3.5918860103951244`*^9, 
   3.592462738297621*^9, 3.5929707685379567`*^9, 3.6022248386777325`*^9, 
   3.6023308315492353`*^9}]
}, Open  ]],

Cell["\<\
The list structure within indexes is allowed but ambivalent. { } are ignored.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "1", ",", 
     RowBox[{"-", "1"}]}], "]"}], "                  ", "//", "Simplify"}], "//",
   "Timing"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "      ", "//", "Simplify"}], "//",
   "Timing"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.187201200000000012`5.292908541611774", ",", 
   FractionBox[
    RowBox[{"16", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "24"}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "4"]}], "+", 
       RowBox[{"37", " ", 
        RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
       RowBox[{"9", " ", 
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
        RowBox[{
         SuperscriptBox["a", 
          TagBox[
           RowBox[{"(", "3", ")"}],
           Derivative],
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "5"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["a", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "+", 
          RowBox[{
           RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
           RowBox[{
            SuperscriptBox["a", 
             TagBox[
              RowBox[{"(", "4", ")"}],
              Derivative],
             MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}]}], 
      ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"4", "+", 
        RowBox[{"K", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[ScriptX]", "2"], "+", 
           SuperscriptBox["\[ScriptY]", "2"], "+", 
           SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"a", "[", "\[Eta]", "]"}], "4"]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721023610552363`*^9, 3.5721023723964567`*^9}, 
   3.572102405796115*^9, 3.572546745503018*^9, 3.5749573951624103`*^9, 
   3.577284614572419*^9, 3.5773449362689333`*^9, 3.5869897464838376`*^9, 
   3.588572980304826*^9, 3.590901863027198*^9, 3.5909098856089535`*^9, 
   3.5909268404377384`*^9, 3.590926887456221*^9, 3.590926924896287*^9, 
   3.591198412433653*^9, 3.5912252523420753`*^9, 3.591262812606312*^9, 
   3.5912669800288315`*^9, 3.5915522907193146`*^9, 3.5916061230153*^9, 
   3.5917768394923306`*^9, 3.5917999425863304`*^9, 3.591886011471526*^9, 
   3.5924627394520226`*^9, 3.59297077016505*^9, 3.6022248403208265`*^9, 
   3.6023308317592354`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1092006999999999978`5.058825335578406", ",", 
   FractionBox[
    RowBox[{"16", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "24"}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "4"]}], "+", 
       RowBox[{"37", " ", 
        RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
       RowBox[{"9", " ", 
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
        RowBox[{
         SuperscriptBox["a", 
          TagBox[
           RowBox[{"(", "3", ")"}],
           Derivative],
          MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "5"}], " ", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["a", "\[Prime]\[Prime]",
              MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "+", 
          RowBox[{
           RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
           RowBox[{
            SuperscriptBox["a", 
             TagBox[
              RowBox[{"(", "4", ")"}],
              Derivative],
             MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}]}], 
      ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"4", "+", 
        RowBox[{"K", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[ScriptX]", "2"], "+", 
           SuperscriptBox["\[ScriptY]", "2"], "+", 
           SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"a", "[", "\[Eta]", "]"}], "4"]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721023610552363`*^9, 3.5721023723964567`*^9}, 
   3.572102405796115*^9, 3.572546745503018*^9, 3.5749573951624103`*^9, 
   3.577284614572419*^9, 3.5773449362689333`*^9, 3.5869897464838376`*^9, 
   3.588572980304826*^9, 3.590901863027198*^9, 3.5909098856089535`*^9, 
   3.5909268404377384`*^9, 3.590926887456221*^9, 3.590926924896287*^9, 
   3.591198412433653*^9, 3.5912252523420753`*^9, 3.591262812606312*^9, 
   3.5912669800288315`*^9, 3.5915522907193146`*^9, 3.5916061230153*^9, 
   3.5917768394923306`*^9, 3.5917999425863304`*^9, 3.591886011471526*^9, 
   3.5924627394520226`*^9, 3.59297077016505*^9, 3.6022248403208265`*^9, 
   3.602330831859236*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["More", "Section"],

Cell[CellGroupData[{

Cell["Zeroth order derivative", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"covariantD", "[", "tRicciR", "]"}], "[", 
  RowBox[{"1", ",", "1"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"covariantD", "::", "zero"}], "MessageName"], 
  RowBox[{":", " "}], "\<\"0-th order derivative\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.590926888563823*^9, 3.5909269257230883`*^9, 
  3.5911984132760544`*^9, 3.5912252531532764`*^9, 3.5912628133863134`*^9, 
  3.591266980871233*^9, 3.591552291639716*^9, 3.5916061239357014`*^9, 
  3.5917768403815317`*^9, 3.5917999435563316`*^9, 3.5918860122827277`*^9, 
  3.5924627404192247`*^9, 3.5929707710791025`*^9, 3.6022248413618865`*^9, 
  3.602330832119236*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox[
        RowBox[{
         SuperscriptBox["a", "\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "+", 
      RowBox[{
       RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
       RowBox[{
        SuperscriptBox["a", "\[Prime]\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"a", "[", "\[Eta]", "]"}], "2"]]}]], "Output",
 CellChangeTimes->{{3.572102362537239*^9, 3.5721023725368567`*^9}, 
   3.572102406700917*^9, 3.572546746453072*^9, 3.574957396051612*^9, 
   3.577284615524021*^9, 3.577344937173735*^9, 3.5869897473886395`*^9, 
   3.588572981272027*^9, 3.5909018639475994`*^9, 3.5909098864825554`*^9, 
   3.5909268405937386`*^9, 3.590926888563823*^9, 3.5909269257386885`*^9, 
   3.5911984132760544`*^9, 3.5912252531688766`*^9, 3.5912628133863134`*^9, 
   3.591266980886833*^9, 3.5915522916553164`*^9, 3.5916061239357014`*^9, 
   3.5917768403815317`*^9, 3.591799943566332*^9, 3.5918860122983274`*^9, 
   3.5924627404192247`*^9, 3.5929707710851026`*^9, 3.602224841366887*^9, 
   3.602330832119236*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"covariantD", "[", "tRicciR", "]"}], "[", 
   RowBox[{"1", ",", "1"}], "]"}], "==", 
  RowBox[{"tRicciR", "[", 
   RowBox[{"1", ",", "1"}], "]"}]}]], "Input"],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.5721023627244396`*^9, 3.572102372661657*^9}, 
   3.572102406856917*^9, 3.5725467466090813`*^9, 3.574957396176412*^9, 
   3.5772846156800213`*^9, 3.5773449373297358`*^9, 3.5869897475446396`*^9, 
   3.5885729814280276`*^9, 3.5909018641036*^9, 3.5909098866697555`*^9, 
   3.590926840718539*^9, 3.5909268887510233`*^9, 3.590926925863489*^9, 
   3.591198413400854*^9, 3.5912252532936773`*^9, 3.5912628135267134`*^9, 
   3.5912669810272336`*^9, 3.5915522917957163`*^9, 3.5916061240917015`*^9, 
   3.591776840553132*^9, 3.591799943716332*^9, 3.5918860124387283`*^9, 
   3.592462740575225*^9, 3.5929707712391114`*^9, 3.6022248415388966`*^9, 
   3.6023308321392365`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Full form and short names", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"covariantD", "[", "metricExt", "]"}], "[", 
   RowBox[{"1", ",", "1", ",", 
    RowBox[{"-", "1"}]}], "]"}], "  ", 
  RowBox[{"(*", " ", "full", " ", "*)"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[EmptyDownTriangle]", "[", "g\[DoubleDagger]", "]"}], "[", 
   RowBox[{"1", ",", "1", ",", 
    RowBox[{"-", "1"}]}], "]"}], "  ", 
  RowBox[{"(*", " ", "short", " ", "*)"}]}]}], "Input"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.57210236289604*^9, 3.5721023728956575`*^9}, 
   3.5721024069973173`*^9, 3.572546746782091*^9, 3.5749573963324127`*^9, 
   3.577284615851621*^9, 3.577344937501336*^9, 3.58698974771624*^9, 
   3.588572981599628*^9, 3.5909018643220005`*^9, 3.5909098868257556`*^9, 
   3.5909268409213395`*^9, 3.5909268889226236`*^9, 3.590926926003889*^9, 
   3.5911984135568547`*^9, 3.591225253465277*^9, 3.591262813682714*^9, 
   3.5912669812144337`*^9, 3.591552292014117*^9, 3.591606124263302*^9, 
   3.5917768407403326`*^9, 3.5917999438963323`*^9, 3.5918860125947285`*^9, 
   3.592462740778025*^9, 3.5929707714261217`*^9, 3.6022248417909107`*^9, 
   3.602330832169236*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.57210236289604*^9, 3.5721023728956575`*^9}, 
   3.5721024069973173`*^9, 3.572546746782091*^9, 3.5749573963324127`*^9, 
   3.577284615851621*^9, 3.577344937501336*^9, 3.58698974771624*^9, 
   3.588572981599628*^9, 3.5909018643220005`*^9, 3.5909098868257556`*^9, 
   3.5909268409213395`*^9, 3.5909268889226236`*^9, 3.590926926003889*^9, 
   3.5911984135568547`*^9, 3.591225253465277*^9, 3.591262813682714*^9, 
   3.5912669812144337`*^9, 3.591552292014117*^9, 3.591606124263302*^9, 
   3.5917768407403326`*^9, 3.5917999438963323`*^9, 3.5918860125947285`*^9, 
   3.592462740778025*^9, 3.5929707714261217`*^9, 3.6022248417909107`*^9, 
   3.602330832169236*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"covariantD", "[", "tEinsteinG", "]"}], "[", 
   RowBox[{"1", ",", "1", ",", 
    RowBox[{"-", "1"}]}], "]"}], "  ", 
  RowBox[{"(*", " ", "full", " ", "*)"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"\[EmptyDownTriangle]", "[", "G\[DoubleDagger]", "]"}], "[", 
   RowBox[{"1", ",", "1", ",", 
    RowBox[{"-", "1"}]}], "]"}], "  ", 
  RowBox[{"(*", " ", "short", " ", "*)"}]}]}], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"K", " ", 
      SuperscriptBox[
       RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], "-", 
     RowBox[{
      RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"a", "[", "\[Eta]", "]"}], "5"]]], "Output",
 CellChangeTimes->{{3.57210236303644*^9, 3.5721023730516577`*^9}, 
   3.572102407184518*^9, 3.5725467469611015`*^9, 3.5749573965040126`*^9, 
   3.5772846160700216`*^9, 3.577344937657336*^9, 3.5869897479034405`*^9, 
   3.5885729818180285`*^9, 3.590901864509201*^9, 3.5909098870129557`*^9, 
   3.5909268411085396`*^9, 3.5909268893438244`*^9, 3.5909269261754894`*^9, 
   3.5911984137128553`*^9, 3.5912252536680775`*^9, 3.5912628139323144`*^9, 
   3.591266981370434*^9, 3.591552292185717*^9, 3.591606124481702*^9, 
   3.591776841021133*^9, 3.5917999440963326`*^9, 3.591886012781928*^9, 
   3.5924627409808254`*^9, 3.592970771615133*^9, 3.6022248422819395`*^9, 
   3.6023308321992364`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"K", " ", 
      SuperscriptBox[
       RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{
        SuperscriptBox["a", "\[Prime]",
         MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], "-", 
     RowBox[{
      RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
      RowBox[{
       SuperscriptBox["a", "\[Prime]\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"a", "[", "\[Eta]", "]"}], "5"]]], "Output",
 CellChangeTimes->{{3.57210236303644*^9, 3.5721023730516577`*^9}, 
   3.572102407184518*^9, 3.5725467469611015`*^9, 3.5749573965040126`*^9, 
   3.5772846160700216`*^9, 3.577344937657336*^9, 3.5869897479034405`*^9, 
   3.5885729818180285`*^9, 3.590901864509201*^9, 3.5909098870129557`*^9, 
   3.5909268411085396`*^9, 3.5909268893438244`*^9, 3.5909269261754894`*^9, 
   3.5911984137128553`*^9, 3.5912252536680775`*^9, 3.5912628139323144`*^9, 
   3.591266981370434*^9, 3.591552292185717*^9, 3.591606124481702*^9, 
   3.591776841021133*^9, 3.5917999440963326`*^9, 3.591886012781928*^9, 
   3.5924627409808254`*^9, 3.592970771615133*^9, 3.6022248422819395`*^9, 
   3.6023308321992364`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example: using Outer with covariantD", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Outer", "[", 
      RowBox[{
       RowBox[{"\[EmptyDownTriangle]", "[", "g\[DoubleDagger]", "]"}], ",", 
       "all", ",", "all", ",", "all"}], "]"}], "//", "Flatten"}], "//", 
    "DeleteDuplicates"}], "//", "Timing"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1404008999999999951`5.167969805003475", ",", 
   RowBox[{"{", "0", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721023638788414`*^9, 3.5721023732700577`*^9}, 
   3.572102407948919*^9, 3.572546748009161*^9, 3.574957397268414*^9, 
   3.577284617021623*^9, 3.5773449386869383`*^9, 3.586989748901842*^9, 
   3.5885729827852297`*^9, 3.5909018655076027`*^9, 3.590909888058158*^9, 
   3.590926841716941*^9, 3.5909268900926256`*^9, 3.5909269268930902`*^9, 
   3.5911984144460564`*^9, 3.5912252544168787`*^9, 3.5912628147123156`*^9, 
   3.5912669821036353`*^9, 3.591552293152919*^9, 3.5916061254957037`*^9, 
   3.591776842113135*^9, 3.591799945206334*^9, 3.5918860136087303`*^9, 
   3.5924627419948273`*^9, 3.5929707726791935`*^9, 3.602224843127988*^9, 
   3.6023308323692365`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Outer", "[", 
    RowBox[{
     RowBox[{"covariantD", "[", "tRicciR", "]"}], ",", "all", ",", "all", ",",
      "all"}], "]"}], "//", "Simplify"}], "//", "MatrixForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], 
                "-", 
                RowBox[{"5", " ", 
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
                 RowBox[{
                  SuperscriptBox["a", 
                   TagBox[
                    RowBox[{"(", "3", ")"}],
                    Derivative],
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             SuperscriptBox[
              RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]}]},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"16", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], 
                "+", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "K", " ", 
                    RowBox[{
                    SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
                   RowBox[{
                    SuperscriptBox["a", 
                    TagBox[
                    RowBox[{"(", "3", ")"}],
                    Derivative],
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
                  ")"}]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"16", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], 
                "+", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "K", " ", 
                    RowBox[{
                    SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
                   RowBox[{
                    SuperscriptBox["a", 
                    TagBox[
                    RowBox[{"(", "3", ")"}],
                    Derivative],
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
                  ")"}]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"32", " ", 
              RowBox[{
               SuperscriptBox["a", "\[Prime]",
                MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"K", " ", 
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
                "-", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
               ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {"0"},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", 
       TagBox[GridBox[{
          {
           RowBox[{"-", 
            FractionBox[
             RowBox[{"16", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"4", " ", 
                 SuperscriptBox[
                  RowBox[{
                   SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}], "3"]}], 
                "+", 
                RowBox[{
                 RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
                 RowBox[{
                  SuperscriptBox["a", "\[Prime]\[Prime]",
                   MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"a", "[", "\[Eta]", "]"}], "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "K", " ", 
                    RowBox[{
                    SuperscriptBox["a", "\[Prime]",
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
                   RowBox[{
                    SuperscriptBox["a", 
                    TagBox[
                    RowBox[{"(", "3", ")"}],
                    Derivative],
                    MultilineFunction->None], "[", "\[Eta]", "]"}]}], 
                  ")"}]}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 RowBox[{"K", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["\[ScriptX]", "2"], "+", 
                    SuperscriptBox["\[ScriptY]", "2"], "+", 
                    SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
               "2"], " ", 
              SuperscriptBox[
               RowBox[{"a", "[", "\[Eta]", "]"}], "3"]}]]}]},
          {"0"},
          {"0"},
          {"0"}
         },
         GridBoxAlignment->{
          "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
           "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.5599999999999999]}, 
             Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}, "RowsIndexed" -> {}}],
        Column], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.572102365298444*^9, 3.5721023735040584`*^9}, 
   3.572102409321721*^9, 3.572546749331237*^9, 3.574957399015617*^9, 
   3.5772846180200253`*^9, 3.5773449401065407`*^9, 3.586989749978244*^9, 
   3.588572983970832*^9, 3.5909018665996046`*^9, 3.59090988935296*^9, 
   3.5909268419041414`*^9, 3.590926891371828*^9, 3.590926928141093*^9, 
   3.5911984156940584`*^9, 3.591225255696081*^9, 3.591262816022718*^9, 
   3.5912669833204374`*^9, 3.591552294213721*^9, 3.591606126618906*^9, 
   3.5917768434391375`*^9, 3.591799946536336*^9, 3.5918860149659324`*^9, 
   3.592462743149229*^9, 3.592970774036271*^9, 3.602224844520067*^9, 
   3.6023308326092367`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {3.5689765261927013`*^9}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {3.568976573569985*^9}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {3.5689765583287582`*^9}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {3.568981227090465*^9}, FontFamily -> "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {3.5689812390088863`*^9}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", CellChangeTimes -> {3.568980449396245*^9}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3602334430-3770194"->{
  Cell[7281, 221, 365, 6, 44, "Print",
   CellTags->"Info3602334430-3770194"]},
 "Info3602334431-3770194"->{
  Cell[7779, 237, 198, 4, 40, "Print",
   CellTags->"Info3602334431-3770194"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3602334430-3770194", 70785, 1905},
 {"Info3602334431-3770194", 70894, 1908}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 80, 2, 69, "Title"],
Cell[CellGroupData[{
Cell[685, 28, 34, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[744, 32, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[798, 36, 111, 3, 65, "Input"],
Cell[912, 41, 235, 6, 70, "Print"],
Cell[1150, 49, 812, 13, 70, "Output"]
}, Open  ]],
Cell[1977, 65, 652, 18, 28, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[2666, 88, 55, 0, 25, "Subsection"],
Cell[CellGroupData[{
Cell[2746, 92, 34, 0, 44, "Input"],
Cell[2783, 94, 3411, 85, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[6255, 186, 29, 0, 38, "Section"],
Cell[6287, 188, 47, 0, 28, "Text"],
Cell[6337, 190, 329, 11, 28, "Text"],
Cell[6669, 203, 467, 7, 62, "Text"],
Cell[CellGroupData[{
Cell[7161, 214, 39, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[7225, 218, 53, 1, 44, "Input"],
Cell[7281, 221, 365, 6, 44, "Print",
 CellTags->"Info3602334430-3770194"]
}, Open  ]],
Cell[7661, 230, 27, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[7713, 234, 63, 1, 44, "Input"],
Cell[7779, 237, 198, 4, 40, "Print",
 CellTags->"Info3602334431-3770194"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8038, 248, 27, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[8090, 252, 63, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[8178, 256, 55, 1, 44, "Input"],
Cell[8236, 259, 1026, 21, 49, "Output"]
}, Open  ]],
Cell[9277, 283, 33, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[9335, 287, 178, 4, 65, "Input"],
Cell[9516, 293, 1658, 42, 55, "Output"],
Cell[11177, 337, 1658, 42, 55, "Output"]
}, Open  ]],
Cell[12850, 382, 34, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[12909, 386, 623, 19, 85, "Input"],
Cell[13535, 407, 2517, 69, 52, "Output"]
}, Open  ]],
Cell[16067, 479, 638, 20, 28, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16742, 504, 53, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[16820, 508, 421, 12, 65, "Input"],
Cell[17244, 522, 1775, 41, 55, "Output"],
Cell[19022, 565, 2536, 63, 55, "Output"]
}, Open  ]],
Cell[21573, 631, 101, 2, 28, "Text"],
Cell[CellGroupData[{
Cell[21699, 637, 608, 18, 65, "Input"],
Cell[22310, 657, 2924, 75, 59, "Output"],
Cell[25237, 734, 2923, 75, 59, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28221, 816, 23, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[28269, 820, 45, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[28339, 824, 120, 3, 44, "Input"],
Cell[28462, 829, 556, 10, 70, "Message"],
Cell[29021, 841, 1228, 27, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30286, 873, 204, 6, 44, "Input"],
Cell[30493, 881, 715, 10, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[31257, 897, 47, 0, 25, "Subsection"],
Cell[CellGroupData[{
Cell[31329, 901, 442, 12, 85, "Input"],
Cell[31774, 915, 706, 10, 70, "Output"],
Cell[32483, 927, 706, 10, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33226, 942, 443, 12, 85, "Input"],
Cell[33672, 956, 1537, 35, 70, "Output"],
Cell[35212, 993, 1537, 35, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[36798, 1034, 58, 0, 25, "Subsection"],
Cell[CellGroupData[{
Cell[36881, 1038, 313, 9, 44, "Input"],
Cell[37197, 1049, 819, 13, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38053, 1067, 226, 6, 44, "Input"],
Cell[38282, 1075, 27299, 708, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
