(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15100,        402]
NotebookOptionsPosition[      8919,        251]
NotebookOutlinePosition[     14464,        379]
CellTagsIndexPosition[     14421,        376]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["installation", "Title",
 CellChangeTimes->{{3.5660705965068007`*^9, 3.5660706003600073`*^9}, {
   3.566070917086164*^9, 3.5660709220001726`*^9}, 3.56906122757182*^9},
 TextAlignment->Right,
 FontSize->18,
 FontSlant->"Italic",
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Read", "Subsection",
 CellChangeTimes->{{3.566235495318799*^9, 3.566235502604012*^9}}],

Cell[TextData[{
 "Installation consists in copying  ",
 StyleBox["ccgrg.m",
  FontSlant->"Italic"],
 "  from"
}], "Text",
 CellChangeTimes->{{3.566235510747226*^9, 3.566235601274185*^9}, {
  3.5662358665058513`*^9, 3.566235868955055*^9}}],

Cell[BoxData[
 RowBox[{"NotebookDirectory", "[", "]"}]], "Input"],

Cell["to", "Text",
 CellChangeTimes->{{3.5662356250174265`*^9, 3.5662356300718355`*^9}}],

Cell[BoxData[
 RowBox[{"FileNameJoin", "[", 
  RowBox[{"{", 
   RowBox[{"$UserBaseDirectory", ",", "\"\<Applications\>\""}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.566235714296384*^9, 3.5662357180715904`*^9}}],

Cell[TextData[{
 "The previous copy of ",
 StyleBox["ccgrg.m",
  FontSlant->"Italic"],
 " is removed, if any. Installation goes quietly."
}], "Text",
 CellChangeTimes->{{3.566235782218903*^9, 3.56623584864382*^9}, {
   3.5691306436106834`*^9, 3.5691306697407293`*^9}, 3.569130700613184*^9, {
   3.569131843295191*^9, 3.569131853778409*^9}, {3.569145423617877*^9, 
   3.569145454661931*^9}}],

Cell[TextData[{
 "(Installation does ",
 StyleBox["not!",
  FontWeight->"Bold"],
 " affect the system registry.)"
}], "Text",
 CellChangeTimes->{{3.566235782218903*^9, 3.56623584864382*^9}, {
  3.5691306436106834`*^9, 3.5691306697407293`*^9}, {3.569130700613184*^9, 
  3.569130721782421*^9}, {3.5691308642106714`*^9, 3.569130865942274*^9}, {
  3.5691308997631335`*^9, 3.5691309047863426`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Install", "Subsection",
 CellChangeTimes->{{3.5662354823395767`*^9, 3.566235489671589*^9}}],

Cell[TextData[{
 "To install the package press:  ",
 Cell[BoxData[
  ButtonBox[
   PaneSelectorBox[{False->
    StyleBox["\<\" Install \"\>", "Hyperlink",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12], True->
    StyleBox["\<\" Install \"\>", "HyperlinkActive",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12]}, Dynamic[
     CurrentValue["MouseOver"]],
    FrameMargins->0,
    ImageSize->Automatic],
   Appearance->Automatic,
   ButtonFunction:>(
    Module[{$CellContext`stad, $CellContext`tam, $CellContext`staddate, \
$CellContext`tamdate}, $CellContext`stad = FileNameJoin[{
          NotebookDirectory[], "ccgrg.m"}]; $CellContext`tam = 
       FileNameJoin[{$UserBaseDirectory, "Applications", 
          "ccgrg.m"}]; $CellContext`staddate = If[
         FileExistsQ[$CellContext`stad], 
         FileDate[$CellContext`stad]]; $CellContext`tamdate = If[
         FileExistsQ[$CellContext`tam], 
         FileDate[$CellContext`tam]]; If[
        Not[
         FileExistsQ[$CellContext`stad]], Print["Missing file to install"]; If[
          FileExistsQ[$CellContext`tam], 
          Print["hold version:  ", 
           DateString[$CellContext`tamdate]]]; Abort[]]; 
      If[$CellContext`staddate == $CellContext`tamdate, Print["same files:  ", 
          DateString[$CellContext`tamdate]]; Abort[]]; If[
        Not[
         FileExistsQ[$CellContext`tam]], 
        CopyFile[$CellContext`stad, $CellContext`tam]; 
        Print["installed version:  ", 
          DateString[$CellContext`staddate]], DeleteFile[$CellContext`tam]; 
        CopyFile[$CellContext`stad, $CellContext`tam]; Print["version: ", 
          DateString[$CellContext`tamdate], "  replaced by:  ", 
          DateString[$CellContext`staddate]]]; Null]; Null),
   Evaluator->Automatic,
   Method->"Preemptive"]],
  CellChangeTimes->{{3.577337017715747*^9, 3.577337079445055*^9}, 
    3.57733711630792*^9, 3.5773371558071895`*^9, 3.5773372294393187`*^9, 
    3.5773373500899305`*^9, 3.5773374166084476`*^9}]
}], "Text",
 CellChangeTimes->{{3.566253881428995*^9, 3.5662539119114485`*^9}, {
   3.5662539965883975`*^9, 3.5662540196764383`*^9}, {3.566537907848188*^9, 
   3.566537908628189*^9}, {3.569130762763693*^9, 3.5691307711253076`*^9}, {
   3.569131300091037*^9, 3.5691313049582453`*^9}, 3.5773374567473183`*^9, {
   3.5773430647648463`*^9, 3.577343090192891*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"version: \"\>", 
   "\[InvisibleSpace]", "\<\"Fri 1 Nov 2013 15:44:30\"\>", 
   "\[InvisibleSpace]", "\<\"  replaced by:  \"\>", 
   "\[InvisibleSpace]", "\<\"Wed 27 Nov 2013 08:04:23\"\>"}],
  SequenceForm[
  "version: ", "Fri 1 Nov 2013 15:44:30", "  replaced by:  ", 
   "Wed 27 Nov 2013 08:04:23"],
  Editable->False]], "Print",
 CellChangeTimes->{3.602330232836384*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check if installed", "Subsection",
 CellChangeTimes->{{3.569132023194707*^9, 3.569132034816727*^9}, {
  3.5691320794484053`*^9, 3.56913208197561*^9}, {3.5691323138388176`*^9, 
  3.569132317957225*^9}}],

Cell[TextData[{
 "To check if installed press:  ",
 Cell[BoxData[
  ButtonBox[
   PaneSelectorBox[{False->
    StyleBox["\<\" Check \"\>", "Hyperlink",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12], True->
    StyleBox["\<\" Check \"\>", "HyperlinkActive",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12]}, Dynamic[
     CurrentValue["MouseOver"]],
    FrameMargins->0,
    ImageSize->Automatic],
   Appearance->Automatic,
   ButtonFunction:>
    Module[{$CellContext`tam, $CellContext`tamdate}, $CellContext`tam = 
      FileNameJoin[{$UserBaseDirectory, "Applications", 
         "ccgrg.m"}]; $CellContext`tamdate = If[
        FileExistsQ[$CellContext`tam], 
        FileDate[$CellContext`tam]]; If[
       FileExistsQ[$CellContext`tam], 
       Print["installed version:  ", 
        DateString[$CellContext`tamdate]], 
       Print["ccgrg not installed"]]],
   Evaluator->Automatic,
   Method->"Preemptive"]],
  CellChangeTimes->{
   3.577337864157634*^9, {3.5773379141557217`*^9, 3.5773379422357707`*^9}, 
    3.5773380727768*^9, 3.5773429658294725`*^9, 3.577343193496273*^9}]
}], "Text",
 CellChangeTimes->{{3.5773429784186945`*^9, 3.5773430676664515`*^9}, {
   3.5773431067913203`*^9, 3.577343113031331*^9}, 3.577343221685522*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"installed version:  \"\>", 
   "\[InvisibleSpace]", "\<\"Wed 27 Nov 2013 08:04:23\"\>"}],
  SequenceForm["installed version:  ", "Wed 27 Nov 2013 08:04:23"],
  Editable->False]], "Print",
 CellChangeTimes->{3.6023302491454067`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Uninstall", "Subsection",
 CellChangeTimes->{{3.5662354823395767`*^9, 3.566235489671589*^9}, {
  3.5691314583689146`*^9, 3.5691314593361163`*^9}}],

Cell[TextData[{
 "To remove the package press:  ",
 Cell[BoxData[
  ButtonBox[
   PaneSelectorBox[{False->
    StyleBox["\<\" Remove \"\>", "Hyperlink",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12], True->
    StyleBox["\<\" Remove \"\>", "HyperlinkActive",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12]}, Dynamic[
     CurrentValue["MouseOver"]],
    FrameMargins->0,
    ImageSize->Automatic],
   Appearance->Automatic,
   ButtonFunction:>
    Module[{$CellContext`tam, $CellContext`tamdate}, $CellContext`tam = 
      FileNameJoin[{$UserBaseDirectory, "Applications", 
         "ccgrg.m"}]; $CellContext`tamdate = If[
        FileExistsQ[$CellContext`tam], 
        FileDate[$CellContext`tam]]; If[
       FileExistsQ[$CellContext`tam], DeleteFile[$CellContext`tam]; 
       Print["removed version:  ", 
         DateString[$CellContext`tamdate]], 
       Print["No file to remove"]]],
   Evaluator->Automatic,
   Method->"Preemptive"]],
  CellChangeTimes->{
   3.577337864157634*^9, {3.5773379141557217`*^9, 3.5773379422357707`*^9}}]
}], "Text",
 CellChangeTimes->{{3.566253881428995*^9, 3.5662539119114485`*^9}, {
   3.5662539965883975`*^9, 3.5662540196764383`*^9}, {3.566537907848188*^9, 
   3.566537908628189*^9}, {3.569130762763693*^9, 3.5691307711253076`*^9}, {
   3.569131300091037*^9, 3.5691313049582453`*^9}, {3.569131474358943*^9, 
   3.5691314761373463`*^9}, {3.5691315853063374`*^9, 3.569131592669551*^9}, 
   3.577337986383848*^9, {3.5773430664340496`*^9, 3.577343101502911*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {{3.568976128298403*^9, 3.568976151589244*^9}, {
        3.5689765242894983`*^9, 3.5689765261927013`*^9}}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {{3.56897650241826*^9, 3.5689765210758924`*^9}, {
           3.568976571417181*^9, 3.568976573569985*^9}}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {{3.568976536114319*^9, 
           3.5689765583287582`*^9}}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {{3.568976333111162*^9, 3.5689763428923798`*^9}, {
        3.5689812244072604`*^9, 3.568981227090465*^9}}, FontFamily -> 
       "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {{3.5689812314740725`*^9, 
           3.5689812390088863`*^9}}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", 
          CellChangeTimes -> {{3.568980449396245*^9, 
           3.5689804565254574`*^9}}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 260, 6, 69, "Title"],
Cell[CellGroupData[{
Cell[865, 32, 92, 1, 31, "Subsection"],
Cell[960, 35, 238, 7, 28, "Text"],
Cell[1201, 44, 65, 1, 44, "Input"],
Cell[1269, 47, 88, 1, 28, "Text"],
Cell[1360, 50, 219, 5, 44, "Input"],
Cell[1582, 57, 390, 9, 28, "Text"],
Cell[1975, 68, 393, 9, 28, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2405, 82, 97, 1, 31, "Subsection"],
Cell[2505, 85, 2398, 52, 41, "Text"],
Cell[4906, 139, 423, 10, 23, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5366, 154, 207, 3, 31, "Subsection"],
Cell[5576, 159, 1290, 34, 41, "Text"],
Cell[6869, 195, 280, 6, 23, "Print"]
}, Closed]],
Cell[CellGroupData[{
Cell[7186, 206, 152, 2, 25, "Subsection"],
Cell[7341, 210, 1550, 37, 41, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
