(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29664,        823]
NotebookOptionsPosition[     22425,        629]
NotebookOutlinePosition[     27766,        756]
CellTagsIndexPosition[     27681,        751]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Killing vectors and Lie derivative  ", "Title",
 FontSize->18,
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Package", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\n", "version"}], "Input"],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.5945253193688498`*^9, 3.6023310981046143`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Wed 27 Nov 2013 08:04:23\"\>", ",", 
   "52831"}], "}"}]], "Output",
 CellChangeTimes->{{3.57210396147805*^9, 3.5721039741920724`*^9}, 
   3.57210486455997*^9, 3.572286704217658*^9, 3.572545491588298*^9, 
   3.5739180258431015`*^9, 3.5749584435310516`*^9, 3.5772851459093523`*^9, 
   3.581747438225154*^9, 3.586415091363065*^9, 3.588570472399768*^9, 
   3.5908110561416225`*^9, 3.590824851872489*^9, 3.590902919913454*^9, 
   3.5909102505559945`*^9, 3.5911990150315113`*^9, 3.5912254887013025`*^9, 
   3.5912915359161863`*^9, 3.591448949913982*^9, 3.5915130314923687`*^9, 
   3.591606290497194*^9, 3.591778241723793*^9, 3.5918002046431236`*^9, 
   3.591805996867513*^9, 3.5918862729435854`*^9, 3.5924624477627106`*^9, 
   3.5924624798987665`*^9, 3.592971322737655*^9, 3.594463313630481*^9, 
   3.5944792886904097`*^9, 3.594525319510858*^9, 3.6023310981146145`*^9}]
}, Open  ]],

Cell[TextData[{
 ButtonBox["Download ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
 StyleBox[ButtonBox["ccgrg",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.572524842630431*^9, 3.5725248687292767`*^9}},
 TextAlignment->Right]
}, Closed]],

Cell[CellGroupData[{

Cell["3-dim maximally symmetric space", "Subsection",
 CellChangeTimes->{3.5722847659948807`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"{", 
    RowBox[{"\[ScriptX]", ",", "\[ScriptY]", ",", "\[ScriptZ]"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        RowBox[{"K", "/", "4"}], " ", 
        RowBox[{"X", ".", "X"}]}]}], ")"}], "^", 
     RowBox[{"-", "2"}]}], " ", 
    RowBox[{"IdentityMatrix", "[", "dim", "]"}]}]}], ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"open", "[", 
  RowBox[{"X", ",", "g"}], "]"}]], "Input",
 CellChangeTimes->{3.572286675092407*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          FractionBox["1", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0", "0"},
         {"0", 
          FractionBox["1", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0"},
         {"0", "0", 
          FractionBox["1", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.572286706916463*^9, 3.5725454935224085`*^9, 
  3.5739180294155083`*^9, 3.5749584452470546`*^9, 3.5772851476097555`*^9, 
  3.581747440128358*^9, 3.586415093812269*^9, 3.588570474224971*^9, 
  3.5908110581384263`*^9, 3.5908248545244937`*^9, 3.5909029222222586`*^9, 
  3.590910253114399*^9, 3.591199017636716*^9, 3.5912254912597075`*^9, 
  3.591291538599391*^9, 3.591448952768787*^9, 3.591513034815174*^9, 
  3.591606293336399*^9, 3.591778244313941*^9, 3.591800208353129*^9, 
  3.591805999613118*^9, 3.5918862773271933`*^9, 3.592462450211915*^9, 
  3.5924624809751687`*^9, 3.5929713260628457`*^9, 3.594463315948613*^9, 
  3.5944792904445105`*^9, 3.594525322029002*^9, 3.6023310983946147`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Assumptions", "Subsubsection",
 CellChangeTimes->{{3.5918495905709333`*^9, 3.5918495999304686`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"addassumption", "[", 
  RowBox[{"0", "<", 
   RowBox[{"1", "+", 
    RowBox[{
     RowBox[{"K", "/", "4"}], " ", 
     RowBox[{"X", ".", "X"}]}]}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[ScriptX]", "|", "\[ScriptY]", "|", "\[ScriptZ]"}], ")"}], 
   "\[Element]", "Reals"}], "&&", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"K", "|", "\[ScriptX]", "|", "\[ScriptY]", "|", "\[ScriptZ]"}], 
    ")"}], "\[Element]", "Reals"}], "&&", 
  RowBox[{"0", "<", 
   RowBox[{"1", "+", 
    RowBox[{
     FractionBox["1", "4"], " ", "K", " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ScriptX]", "2"], "+", 
       SuperscriptBox["\[ScriptY]", "2"], "+", 
       SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}]}]}]], "Output",
 CellChangeTimes->{{3.572103963802454*^9, 3.572103975237274*^9}, 
   3.5721048666347733`*^9, 3.5722867074624643`*^9, 3.5725454939734344`*^9, 
   3.5739180298523088`*^9, 3.574958445605855*^9, 3.577285148015356*^9, 
   3.5817474405963583`*^9, 3.5864150942334695`*^9, 3.5885704745837717`*^9, 
   3.590811058528427*^9, 3.5908248551952953`*^9, 3.590902922596659*^9, 
   3.5909102535355997`*^9, 3.591199019243519*^9, 3.59122549299131*^9, 
   3.591291540502594*^9, 3.5914489547343903`*^9, 3.591513035251975*^9, 
   3.591606295192802*^9, 3.591778246315055*^9, 3.5918002089631295`*^9, 
   3.591806001500721*^9, 3.591886277857594*^9, {3.5924624518031178`*^9, 
   3.592462481193569*^9}, 3.592971327816946*^9, 3.5944633177487164`*^9, 
   3.5944792909555397`*^9, 3.5945253236890965`*^9, 3.602331098444615*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Killing vectors (example)", "Subsection",
 CellChangeTimes->{{3.591448998882468*^9, 3.591449006105281*^9}}],

Cell["Killing vectors: covariant components", "Text"],

Cell[BoxData[{
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Klcov", "[", "i_", "]"}], "[", "j_", "]"}], ":=", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{"K", " ", 
          RowBox[{"X", ".", "X"}]}], "4"]}], ")"}], 
      RowBox[{"-", "2"}]], 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"k", "=", "1"}], "dim"], 
      RowBox[{
       RowBox[{"X", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
       " ", 
       SubscriptBox["\[CurlyEpsilon]", 
        RowBox[{
        "i", "\[InvisibleComma]", "j", "\[InvisibleComma]", "k"}]]}]}]}]}], 
   ";"}], TraditionalForm], "\n", 
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Ktcov", "[", "i_", "]"}], "[", "j_", "]"}], ":=", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        FractionBox[
         RowBox[{"K", " ", 
          RowBox[{"X", ".", "X"}]}], "4"]}], ")"}], 
      RowBox[{"-", "2"}]], 
     RowBox[{"(", 
      RowBox[{
       TemplateBox[{RowBox[{"i", ",", "j"}]},
        "KroneckerDeltaSeq"], "-", 
       RowBox[{
        FractionBox["1", "4"], " ", "K", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"X", ".", "X"}], " ", 
           TemplateBox[{RowBox[{"i", ",", "j"}]},
            "KroneckerDeltaSeq"]}], "-", 
          RowBox[{"2", " ", 
           RowBox[{
           "X", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], " ", 
           RowBox[{
           "X", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}]}], 
         ")"}]}]}], ")"}]}]}], ";"}], TraditionalForm]}], "Input",
 FontWeight->"Plain"],

Cell["Killing vectors: co- and contravariant", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Kl", "[", 
     RowBox[{"i_Integer", "/;", 
      RowBox[{"0", "<", "i", "<=", "3"}]}], "]"}], "[", "j_", "]"}], ":=", 
   RowBox[{
    RowBox[{"tensorExt", "[", 
     RowBox[{"Klcov", "[", "i", "]"}], "]"}], "[", "j", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Kt", "[", 
     RowBox[{"i_Integer", "/;", 
      RowBox[{"0", "<", "i", "<=", "3"}]}], "]"}], "[", "j_", "]"}], ":=", 
   RowBox[{
    RowBox[{"tensorExt", "[", 
     RowBox[{"Ktcov", "[", "i", "]"}], "]"}], "[", "j", "]"}]}], 
  ";"}]}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Killing equation", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"id1", "[", "K_", "]"}], "[", 
   RowBox[{"e_", ",", "i_", ",", "j_"}], "]"}], ":=", "    ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"covariantD", "[", 
      RowBox[{"K", "[", "e", "]"}], "]"}], "[", 
     RowBox[{"i", ",", "j"}], "]"}], "+", 
    RowBox[{
     RowBox[{"covariantD", "[", 
      RowBox[{"K", "[", "e", "]"}], "]"}], "[", 
     RowBox[{"j", ",", "i"}], "]"}]}], "==", "0"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"verify", "[", 
  RowBox[{
   RowBox[{"id1", "[", "Kl", "]"}], ",", "all", ",", "all", ",", "all"}], 
  "]"}], "\n", 
 RowBox[{"verify", "[", 
  RowBox[{
   RowBox[{"id1", "[", "Kt", "]"}], ",", "all", ",", "all", ",", "all"}], 
  "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2028012999999999899`5.3276706478709865", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.572103964598056*^9, 3.572103975783275*^9}, 
   3.572104867539575*^9, 3.5722867082736654`*^9, 3.572545494878486*^9, 
   3.57391803071031*^9, 3.574958446541857*^9, 3.577285149029358*^9, 
   3.5817474415791597`*^9, 3.5864150957310724`*^9, 3.5885704757225733`*^9, 
   3.590811059573629*^9, 3.590824856786498*^9, 3.590902923688661*^9, 
   3.5909102546588016`*^9, 3.591199020663121*^9, 3.5912254944889126`*^9, 
   3.591291541968997*^9, 3.5914489566531935`*^9, 3.5915130365467772`*^9, 
   3.5916062972208056`*^9, 3.5917782485371823`*^9, 3.5918002099931307`*^9, 
   3.5918060036067247`*^9, 3.5918862792303963`*^9, {3.5924624538155212`*^9, 
   3.5924624815991697`*^9}, 3.5929713308181176`*^9, 3.5944633195438185`*^9, 
   3.594479292044602*^9, 3.5945253264312534`*^9, 3.6023310988046155`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1404008999999999951`5.167969805003475", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.572103964598056*^9, 3.572103975783275*^9}, 
   3.572104867539575*^9, 3.5722867082736654`*^9, 3.572545494878486*^9, 
   3.57391803071031*^9, 3.574958446541857*^9, 3.577285149029358*^9, 
   3.5817474415791597`*^9, 3.5864150957310724`*^9, 3.5885704757225733`*^9, 
   3.590811059573629*^9, 3.590824856786498*^9, 3.590902923688661*^9, 
   3.5909102546588016`*^9, 3.591199020663121*^9, 3.5912254944889126`*^9, 
   3.591291541968997*^9, 3.5914489566531935`*^9, 3.5915130365467772`*^9, 
   3.5916062972208056`*^9, 3.5917782485371823`*^9, 3.5918002099931307`*^9, 
   3.5918060036067247`*^9, 3.5918862792303963`*^9, {3.5924624538155212`*^9, 
   3.5924624815991697`*^9}, 3.5929713308181176`*^9, 3.5944633195438185`*^9, 
   3.594479292044602*^9, 3.5945253264312534`*^9, 3.6023310989446154`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Lie derivative", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"?", "LieD"}]}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"\!\(\*\\nStyleBox[\\\"LieD\\\",\\nFontSlant->\\\"Italic\\\"]\)[\
u][T][i,j] = \!\(\*SubscriptBox[\(\[ScriptCapitalL]\), \
\(u\)]\)\!\(\*SubscriptBox[\(T\), \(ij\)]\)\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.602331099214616*^9},
 CellTags->"Info3602334698-3928909"]
}, Open  ]],

Cell["The metric tensor Lie derivative down the Killing field", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"id2", "[", "K_", "]"}], "[", 
   RowBox[{"e_", ",", "i_", ",", "j_"}], "]"}], ":=", "    ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"LieD", "[", 
      RowBox[{"K", "[", "e", "]"}], "]"}], "[", "g\[DoubleDagger]", "]"}], 
    "[", 
    RowBox[{"i", ",", "j"}], "]"}], "==", "0"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"verify", "[", 
  RowBox[{
   RowBox[{"id2", "[", "Kl", "]"}], ",", "all", ",", "all", ",", "all"}], 
  "]"}], "\n", 
 RowBox[{"verify", "[", 
  RowBox[{
   RowBox[{"id2", "[", "Kt", "]"}], ",", "all", ",", "all", ",", "all"}], 
  "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2028012999999999899`5.3276706478709865", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721039674216604`*^9, 3.5721039776864786`*^9}, 
   3.5721048701603794`*^9, 3.57228671089447*^9, 3.5725454977326493`*^9, 
   3.573918033455915*^9, 3.5749584490066614`*^9, 3.577285151306962*^9, 
   3.5817474442155647`*^9, 3.586415098554677*^9, 3.5885704787177787`*^9, 
   3.5908110626156344`*^9, 3.590824859235702*^9, 3.5909029270270667`*^9, 
   3.590910257607207*^9, 3.591199023003125*^9, 3.591225497296918*^9, 
   3.591291544823802*^9, 3.591448959476799*^9, 3.5915130396199827`*^9, 
   3.5916063002628107`*^9, 3.5917782516393595`*^9, 3.591800212853135*^9, 
   3.5918060063835297`*^9, 3.591886281757601*^9, {3.5924624563427258`*^9, 
   3.5924624834711733`*^9}, 3.592971333512272*^9, 3.594463322569992*^9, 
   3.5944792953807926`*^9, 3.5945253291114073`*^9, 3.6023310995346165`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2652016999999999847`5.444176216942424", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721039674216604`*^9, 3.5721039776864786`*^9}, 
   3.5721048701603794`*^9, 3.57228671089447*^9, 3.5725454977326493`*^9, 
   3.573918033455915*^9, 3.5749584490066614`*^9, 3.577285151306962*^9, 
   3.5817474442155647`*^9, 3.586415098554677*^9, 3.5885704787177787`*^9, 
   3.5908110626156344`*^9, 3.590824859235702*^9, 3.5909029270270667`*^9, 
   3.590910257607207*^9, 3.591199023003125*^9, 3.591225497296918*^9, 
   3.591291544823802*^9, 3.591448959476799*^9, 3.5915130396199827`*^9, 
   3.5916063002628107`*^9, 3.5917782516393595`*^9, 3.591800212853135*^9, 
   3.5918060063835297`*^9, 3.591886281757601*^9, {3.5924624563427258`*^9, 
   3.5924624834711733`*^9}, 3.592971333512272*^9, 3.594463322569992*^9, 
   3.5944792953807926`*^9, 3.5945253291114073`*^9, 3.6023310997946167`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["more...", "Subsubsection",
 CellChangeTimes->{{3.591449047476553*^9, 3.591449060440176*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ncov", "[", "k_", "]"}], ":=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0"}], "}"}], "[", 
    RowBox[{"[", "k", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "[", "k_", "]"}], ":=", " ", 
   RowBox[{
    RowBox[{"unitvector", "[", "ncov", "]"}], "[", "k", "]"}]}], 
  ";"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Outer", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"LieD", "[", "n", "]"}], "[", "g\[DoubleDagger]", "]"}], ",", 
      "all", ",", "all"}], "]"}], "//", "Simplify"}], "//", "MF"}], "//", 
  "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1560010000000000008`5.21372729556415", ",", 
   TagBox[
    RowBox[{"(", "\[NoBreak]", GridBox[{
       {"0", 
        FractionBox[
         RowBox[{"8", " ", "K", " ", "\[ScriptY]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{"K", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ScriptX]", "2"], "+", 
               SuperscriptBox["\[ScriptY]", "2"], "+", 
               SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]], 
        FractionBox[
         RowBox[{"8", " ", "K", " ", "\[ScriptZ]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{"K", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ScriptX]", "2"], "+", 
               SuperscriptBox["\[ScriptY]", "2"], "+", 
               SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]},
       {
        FractionBox[
         RowBox[{"8", " ", "K", " ", "\[ScriptY]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{"K", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ScriptX]", "2"], "+", 
               SuperscriptBox["\[ScriptY]", "2"], "+", 
               SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]], 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", "K", " ", "\[ScriptX]"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"K", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["\[ScriptX]", "2"], "+", 
                SuperscriptBox["\[ScriptY]", "2"], "+", 
                SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], 
           "2"]]}], "0"},
       {
        FractionBox[
         RowBox[{"8", " ", "K", " ", "\[ScriptZ]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"4", "+", 
            RowBox[{"K", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["\[ScriptX]", "2"], "+", 
               SuperscriptBox["\[ScriptY]", "2"], "+", 
               SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]], 
        "0", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", "K", " ", "\[ScriptX]"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"K", " ", 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["\[ScriptX]", "2"], "+", 
                SuperscriptBox["\[ScriptY]", "2"], "+", 
                SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}]}
      },
      GridBoxAlignment->{
       "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
        "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.7]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
    Function[BoxForm`e$, 
     MatrixForm[BoxForm`e$]]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5721039696368647`*^9, 3.572103979761282*^9}, 
   3.5721048722351832`*^9, 3.572286713016074*^9, 3.5725455003247976`*^9, 
   3.573918035530719*^9, 3.5749584510034647`*^9, 3.577285153366165*^9, 
   3.5817474463215685`*^9, 3.586415100801081*^9, 3.5885704815413837`*^9, 
   3.590811064893238*^9, 3.5908248616381063`*^9, 3.5909029292266707`*^9, 
   3.590910260072011*^9, 3.591199025124729*^9, 3.5912254994497213`*^9, 
   3.5912915470234056`*^9, 3.5914489617232027`*^9, 3.5915130419443865`*^9, 
   3.591606302634015*^9, 3.591778254183505*^9, 3.5918002152531385`*^9, 
   3.5918060088639345`*^9, 3.591886283894805*^9, {3.5924624584487295`*^9, 
   3.592462485639577*^9}, 3.5929713359214096`*^9, 3.59446332497913*^9, 
   3.594479303342248*^9, 3.5945253314625416`*^9, 3.602331100004617*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeUsed", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5911989946734753`*^9, 3.5911989995094843`*^9}}],

Cell[BoxData["1.605999999999999`"], "Output",
 CellChangeTimes->{
  3.5911990254835296`*^9, 3.5912254998865223`*^9, 3.591291547397806*^9, 
   3.591448962113203*^9, 3.5915130423811874`*^9, 3.591606302977216*^9, 
   3.591778254701535*^9, 3.591800215683139*^9, 3.5918060093007345`*^9, 
   3.5918862842224054`*^9, {3.5924624585579295`*^9, 3.592462485764377*^9}, 
   3.5929713362224264`*^9, 3.5944633253561516`*^9, 3.594479303971284*^9, 
   3.5945253318065615`*^9, 3.602331100044617*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {3.5689765261927013`*^9}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {3.568976573569985*^9}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {3.5689765583287582`*^9}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {3.568981227090465*^9}, FontFamily -> "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {3.5689812390088863`*^9}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", CellChangeTimes -> {3.568980449396245*^9}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3602334698-3928909"->{
  Cell[13815, 404, 313, 6, 44, "Print",
   CellTags->"Info3602334698-3928909"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3602334698-3928909", 27577, 745}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 96, 2, 69, "Title"],
Cell[CellGroupData[{
Cell[701, 28, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[755, 32, 111, 3, 65, "Input"],
Cell[869, 37, 259, 6, 70, "Print"],
Cell[1131, 45, 933, 14, 70, "Output"]
}, Open  ]],
Cell[2079, 62, 652, 18, 28, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[2768, 85, 97, 1, 25, "Subsection"],
Cell[2868, 88, 463, 16, 65, "Input"],
Cell[CellGroupData[{
Cell[3356, 108, 122, 3, 44, "Input"],
Cell[3481, 113, 3067, 75, 174, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6585, 193, 106, 1, 29, "Subsubsection"],
Cell[CellGroupData[{
Cell[6716, 198, 190, 6, 44, "Input"],
Cell[6909, 206, 1405, 29, 46, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8375, 242, 113, 1, 31, "Subsection"],
Cell[8491, 245, 53, 0, 28, "Text"],
Cell[8547, 247, 1706, 55, 111, "Input"],
Cell[10256, 304, 54, 0, 28, "Text"],
Cell[10313, 306, 597, 19, 65, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10947, 330, 38, 0, 31, "Subsection"],
Cell[10988, 332, 459, 14, 44, "Input"],
Cell[CellGroupData[{
Cell[11472, 350, 272, 8, 65, "Input"],
Cell[11747, 360, 944, 14, 31, "Output"],
Cell[12694, 376, 943, 14, 31, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13686, 396, 36, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[13747, 400, 65, 2, 44, "Input"],
Cell[13815, 404, 313, 6, 44, "Print",
 CellTags->"Info3602334698-3928909"]
}, Open  ]],
Cell[14143, 413, 71, 0, 28, "Text"],
Cell[14217, 415, 349, 11, 44, "Input"],
Cell[CellGroupData[{
Cell[14591, 430, 272, 8, 65, "Input"],
Cell[14866, 440, 942, 14, 31, "Output"],
Cell[15811, 456, 941, 14, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16789, 475, 98, 1, 29, "Subsubsection"],
Cell[16890, 478, 379, 13, 65, "Input"],
Cell[CellGroupData[{
Cell[17294, 495, 279, 9, 44, "Input"],
Cell[17576, 506, 4149, 101, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21762, 612, 126, 2, 44, "Input"],
Cell[21891, 616, 482, 7, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
