(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     51239,       1433]
NotebookOptionsPosition[     42875,       1200]
NotebookOutlinePosition[     48063,       1321]
CellTagsIndexPosition[     48020,       1318]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["the memory content", "Title"],

Cell[CellGroupData[{

Cell["Initial section", "Section"],

Cell[CellGroupData[{

Cell["Package", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\n", "version"}], "Input"],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.594486761850361*^9, 3.5944868629041414`*^9, 
  3.5944869632448807`*^9, 3.594487085902896*^9, 3.5944874003248796`*^9, 
  3.5944907985210967`*^9, 3.5945251835100794`*^9, 3.602330991763463*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Wed 27 Nov 2013 08:04:23\"\>", ",", 
   "52831"}], "}"}]], "Output",
 CellChangeTimes->{3.572105341250007*^9, 3.572105538309553*^9, 
  3.5725447496318607`*^9, 3.572546573448177*^9, 3.5736771775779533`*^9, 
  3.5742001049533815`*^9, 3.57424167670035*^9, 3.5742417217064285`*^9, 
  3.5772849507842093`*^9, 3.5773451007244225`*^9, 3.581746693542246*^9, 
  3.586414908546344*^9, 3.586731350380801*^9, 3.5867317427682905`*^9, 
  3.58698980479674*^9, 3.590810831797629*^9, 3.5908245355819335`*^9, 
  3.5909019633665743`*^9, 3.5909100354940166`*^9, 3.5944856553920755`*^9, 
  3.5944857839974313`*^9, 3.5944858491341567`*^9, 3.5944867618563614`*^9, 
  3.5944868629971466`*^9, 3.5944869633398857`*^9, 3.594487086025903*^9, 
  3.5944874004178853`*^9, 3.594490798636103*^9, 3.5945251836240854`*^9, 
  3.6023309917834635`*^9}]
}, Open  ]],

Cell[TextData[{
 ButtonBox["Download ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
 StyleBox[ButtonBox["ccgrg",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.572524842630431*^9, 3.5725248687292767`*^9}},
 TextAlignment->Right]
}, Closed]],

Cell[CellGroupData[{

Cell["Schwarzschild metric tensor", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData["Schwarzschild"], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           FractionBox[
            RowBox[{"2", " ", "M"}], "\[ScriptR]"]}], "0", "0", "0"},
         {"0", 
          FractionBox["1", 
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"2", " ", "M"}], "\[ScriptR]"]}]], "0", "0"},
         {"0", "0", 
          SuperscriptBox["\[ScriptR]", "2"], "0"},
         {"0", "0", "0", 
          RowBox[{
           SuperscriptBox["\[ScriptR]", "2"], " ", 
           SuperscriptBox[
            RowBox[{"Sin", "[", "\[CurlyTheta]", "]"}], "2"]}]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.572105343512011*^9, 3.5721055405871572`*^9, 
  3.572544752175006*^9, 3.5725465760623264`*^9, 3.5736771800895576`*^9, 
  3.5742001080889874`*^9, 3.574241681177558*^9, 3.5742417239840326`*^9, 
  3.5772849530774136`*^9, 3.5773451031424265`*^9, 3.5817466962410507`*^9, 
  3.586414911104748*^9, 3.5867313527208056`*^9, 3.586731745248695*^9, 
  3.586989807495545*^9, 3.590810834730434*^9, 3.5908245384523387`*^9, 
  3.590901966049779*^9, 3.5909100380836215`*^9, 3.5944856617564397`*^9, 
  3.5944857902277875`*^9, 3.5944858520523243`*^9, 3.5944867698418183`*^9, 
  3.594486866293335*^9, 3.594486967308113*^9, 3.5944870900381327`*^9, 
  3.5944874047021303`*^9, 3.594490802436321*^9, 3.5945251871202855`*^9, 
  3.602330992213464*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"addassumption", "[", 
   RowBox[{"\[ScriptR]", "<", 
    RowBox[{"2", "M"}]}], "]"}], ";"}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Functions that remember...", "Section",
 CellChangeTimes->{{3.572105508451101*^9, 3.5721055089191017`*^9}}],

Cell[CellGroupData[{

Cell["Memoizing  functions", "Subsection",
 CellChangeTimes->{{3.5736647441442795`*^9, 3.573664766655119*^9}}],

Cell[TextData[{
 "tutorial/FunctionsThatRememberValuesTheyHaveFound\n(",
 ButtonBox["http://en.wikipedia.org/wiki/Memoization",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://en.wikipedia.org/wiki/Memoization"], None},
  ButtonNote->"http://en.wikipedia.org/wiki/Memoization"],
 ")"
}], "Text",
 CellChangeTimes->{{3.5691333615522575`*^9, 3.5691333699918723`*^9}, {
  3.569190897629773*^9, 3.569190899096175*^9}, {3.569190953696271*^9, 
  3.569190953711871*^9}, {3.5708705027246747`*^9, 3.5708705644071827`*^9}},
 TextAlignment->Right],

Cell["Constructions of the form:", "Text",
 CellChangeTimes->{{3.5736777784910088`*^9, 3.573677812077868*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "x_", "]"}], ":=", 
   RowBox[{
    RowBox[{"f", "[", "x", "]"}], "=", 
    RowBox[{"expr", "[", "x", "]"}]}]}], ";"}]], "Input"],

Cell["or", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "x_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", 
     RowBox[{
      RowBox[{"f", "[", "x", "]"}], "=", 
      RowBox[{"expr", "[", "x", "]"}]}]}], "]"}]}], ";"}]], "Input"],

Cell[TextData[{
 "are widely employed in the Package. Constructions like that (memoizing \
functions)  allow to compute quantities when  needed   (lazy evaluation) and \
instantly cache the found values.   ",
 StyleBox["ccgrg package",
  FontSlant->"Italic"],
 " avoids evaluating in advance quantities which are not necessary  at the \
current level of calculation. This makes computation quicker, but..."
}], "Text",
 CellChangeTimes->{{3.5736646223628645`*^9, 3.573664625826071*^9}, 
   3.5736777759170046`*^9, {3.573677818380279*^9, 3.573677834510707*^9}, {
   3.573677865476762*^9, 3.5736778866615987`*^9}, {3.573678094422764*^9, 
   3.5736781170272036`*^9}, {3.57367815513807*^9, 3.5736781637804856`*^9}, {
   3.573714990819722*^9, 3.5737149997897377`*^9}, {3.573736957065238*^9, 
   3.57373695815724*^9}, {3.573736988717694*^9, 3.5737370884486685`*^9}, {
   3.573737294727831*^9, 3.5737372951958323`*^9}, {3.57375046410072*^9, 
   3.5737504692380133`*^9}, {3.5737508189530163`*^9, 
   3.5737508392911797`*^9}, {3.5737587703206744`*^9, 
   3.5737587875119047`*^9}, {3.5737588281187763`*^9, 3.5737588289455776`*^9}, 
   3.5739167752357054`*^9, {3.5739169070871363`*^9, 3.5739169780360613`*^9}, {
   3.5739170162873287`*^9, 3.5739170278469486`*^9}}],

Cell["\<\
while working with memoizing functions, some additional programming \
constraints  are indispensable to keep calculations at the proper level of \
reliability.  In particular:\
\>", "Text",
 CellChangeTimes->{{3.5736677822620487`*^9, 3.573667785584854*^9}, {
   3.573737112363511*^9, 3.5737371603335953`*^9}, 3.5737373210294776`*^9, {
   3.573750509164297*^9, 3.573750568741705*^9}, 3.573758791255911*^9}],

Cell["\<\
User must not!  assign different expressions (expr) to the same symbol (f) \
during the current session,
 and pay extreme attention if such conflicting assignment occur.\
\>", "Text",
 CellChangeTimes->{{3.5722724187819653`*^9, 3.5722724419480057`*^9}, {
   3.5722726662763996`*^9, 3.572272680878025*^9}, 3.573667795600072*^9},
 TextAlignment->Center,
 FontWeight->"Bold"],

Cell["\<\
Sections below provide the tools to remove potential conflicts. Tools \
discussed below are not necessary, if all functions used in the notebook are \
defined uniquely, and the metric is fixed.\
\>", "Text",
 CellChangeTimes->{{3.57367757439585*^9, 3.573677652739188*^9}, {
   3.5736776889312515`*^9, 3.5736777161220994`*^9}, {3.5737372294417167`*^9, 
   3.573737275274597*^9}, 3.5737506088199973`*^9, {3.5737588784600644`*^9, 
   3.5737588905968857`*^9}, {3.573917093476264*^9, 3.5739170936790648`*^9}, {
   3.594486032171626*^9, 3.5944860328076625`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The memory content", "Section"],

Cell[CellGroupData[{

Cell[TextData[{
 "Protecting user-defined tensors (",
 StyleBox["erasable, retreat",
  FontSlant->"Italic"],
 ")"
}], "Subsection",
 CellChangeTimes->{
  3.573663313642434*^9, {3.5736754738457584`*^9, 3.5736754807409706`*^9}, 
   3.574199509533538*^9}],

Cell[TextData[{
 "Memoizing functions are reluctant to modify. New definitions of the \
function (with the same symbol name) does not overwrite the previously \
computed values. To efficiently redefine function or tensor of this type one \
shall clear the cache first. To easily handle with memoized functions, a \
class of ",
 StyleBox["erasable",
  FontSlant->"Italic"],
 " functions is introduced. Command ",
 StyleBox["erasable",
  FontSlant->"Italic"],
 " adds the user-defined function/tensor  to the list ",
 StyleBox["memRegistry :",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->CompressedData["
1:eJwdy2kog3EAx/HHEGU1TGKhaZII88JizdbW8NpRk5pytfHCMUcrRbMXMzne
sM2RtnkjR46WlowsSSKUIyVXy/GkhAxbyvP7v/j2efVNrWstb2RRFJXMBC1j
2tFCOy2PiDpywBl+2DLUG/JckK4O7sClLuUBHAgkHsP2G8sJbIvefIFpkfQb
7BRxJGLGjy9fETRJt4qhwXVB3B8pVcH4DEUVXHcK1VDnbKqB5rAiDbRQfVpo
F/l1MOWwuRu6PL9G8k0ETPDzJ28bpn8IdiG9EW6WMsay9cTNFa8V6r3HNvjE
ci9A/h17Ef5w51ZhtTp7DWYKk05h8Fp1BuOmL6/g2GOSDyp5nX6Yk2X8hhJF
rkDGyLXaiKMh4ha4qJS1Q96e6h3ahUPESZvgtoyxwV1yD4cDVKiaMaailvia
MN9az1jwzOmA+d5zJ5T1y2fhkaCyR8NImceJD2meKamDlvcO/hH/AX+u6/I=

  "]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"erasable", "[", "mytensor", "]"}], "\n", "memRegistry"}], "Input",
 CellChangeTimes->{3.5736633150464363`*^9, 3.5736657614688663`*^9, 
  3.5741995213115587`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "x\[DoubleDagger]", ",", "g\[DoubleDagger]", ",", "gAux", ",", "etaExt", 
   ",", "\[CapitalGamma]", ",", "ccgrg`Private`\[CapitalGamma]Aux", ",", 
   "Riem", ",", "tRiemannR", ",", "Ric", ",", "tRicciR", ",", "tEinsteinG", 
   ",", "tWeylC", ",", "tWeylCdual", ",", "covariantD", ",", 
   "ccgrg`Private`hcov$965", ",", "h\[DoubleDagger]", ",", 
   "ccgrg`Private`\[Chi]cov$965", ",", "\[Chi]\[DoubleDagger]", ",", 
   "t\[Theta]", ",", "s\[Theta]", ",", "t\[Theta]cov", ",", "t\[Omega]", ",", 
   "s\[Omega]", ",", "t\[Omega]cov", ",", "t\[Sigma]", ",", "s\[Sigma]", ",", 
   "tPlebanskiS", ",", "mytensor"}], "}"}]], "Output",
 CellChangeTimes->{3.5721053440112123`*^9, 3.572105541086358*^9, 
  3.5725447528180428`*^9, 3.57254657682537*^9, 3.573677180651159*^9, 
  3.5742001086661882`*^9, 3.5742416816143584`*^9, 3.5742417244832335`*^9, 
  3.5772849536078143`*^9, 3.577345103828828*^9, 3.581746696849452*^9, 
  3.5864149117287493`*^9, 3.5867313532824063`*^9, 3.5867317457010956`*^9, 
  3.5869898079947457`*^9, 3.5908108353076353`*^9, 3.59082453916994*^9, 
  3.59090196661138*^9, 3.5909100387232227`*^9, 3.5944856666217175`*^9, 
  3.594485795042063*^9, 3.594485852433346*^9, 3.5944867715269146`*^9, 
  3.59448686830945*^9, 3.5944869683271713`*^9, 3.5944870921512537`*^9, 
  3.594487407268277*^9, 3.5944908045114393`*^9, 3.594525189663431*^9, 
  3.602330992243464*^9}]
}, Open  ]],

Cell[TextData[{
 "The cache of ",
 StyleBox[" erasable",
  FontSlant->"Italic"],
 " tensors (listed in ",
 StyleBox["memRegistry)",
  FontSlant->"Italic"],
 " is automatically cleared  whenever metrics changes. Command  ",
 StyleBox["retreat",
  FontSlant->"Italic"],
 " allow to clear the cache of any individual function on demand, at any \
stage of calculations (see below the section ",
 StyleBox["Clearing the memory content",
  FontSlant->"Italic"],
 ")."
}], "Text",
 CellChangeTimes->{
  3.572272498482505*^9, {3.5736647914279623`*^9, 3.5736647930347652`*^9}, {
   3.5736654514807215`*^9, 3.5736654536959257`*^9}, {3.573665494302797*^9, 
   3.5736655056440167`*^9}, {3.5736664577413225`*^9, 
   3.5736664596133256`*^9}, {3.573666658529275*^9, 3.573666667608491*^9}, {
   3.5736669106569176`*^9, 3.573666929720151*^9}, {3.573666975740232*^9, 
   3.573666992104661*^9}, {3.573667052039966*^9, 3.5736670726944027`*^9}, {
   3.573667103161256*^9, 3.5736671269356976`*^9}, {3.573667197931422*^9, 
   3.5736672981927986`*^9}, 3.5736674190462103`*^9, {3.5736674549886737`*^9, 
   3.573667465768293*^9}, {3.573675236460141*^9, 3.5736752659909935`*^9}, {
   3.5736758644928455`*^9, 3.573675865709648*^9}, {3.5736758972997036`*^9, 
   3.5736759248025513`*^9}, {3.57367601475231*^9, 3.573676078603222*^9}, {
   3.573676112439681*^9, 3.573676144638138*^9}, 3.5736761800342016`*^9, {
   3.5736763635061235`*^9, 3.5736763681861315`*^9}, {3.5736763983721848`*^9, 
   3.573676434907449*^9}, {3.5736765420952373`*^9, 3.5736766457574196`*^9}, {
   3.573676721854353*^9, 3.5736767533040085`*^9}, {3.5736769455119457`*^9, 
   3.573676950691155*^9}, {3.573678252716242*^9, 3.5736782616862574`*^9}, {
   3.5737147489256973`*^9, 3.5737148817287307`*^9}, {3.5737149127259855`*^9, 
   3.57371491568999*^9}, 3.573751117826111*^9, {3.573751153990179*^9, 
   3.573751176500467*^9}, {3.5737589774890385`*^9, 3.5737589921218643`*^9}, {
   3.573759043792509*^9, 3.5737590454305124`*^9}, {3.5737590784401703`*^9, 
   3.5737591001398087`*^9}, 3.573759251865675*^9, {3.5737592841577315`*^9, 
   3.573759287308937*^9}, {3.573759331441415*^9, 3.573759339506629*^9}, {
   3.5737593712994847`*^9, 3.5737593795830994`*^9}, {3.573917208994467*^9, 
   3.5739172172312813`*^9}, 3.5741995231991615`*^9, {3.574241852918259*^9, 
   3.574241860827473*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Displaying cashed tensor components (",
 StyleBox["cacheview",
  FontSlant->"Italic"],
 ")"
}], "Subsection",
 CellChangeTimes->{
  3.572272526094554*^9, {3.573665529044058*^9, 3.5736655304012604`*^9}, 
   3.5748484682172437`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"tRicciR", "[", 
  RowBox[{"1", ",", "1"}], "]"}], "\n", 
 RowBox[{
  RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
  RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], "]"}]}], "Input"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.572105344136012*^9, 3.5721055412267585`*^9, 
  3.572544753102059*^9, 3.5725465770643835`*^9, 3.5736771808071594`*^9, 
  3.5742001088533883`*^9, 3.5742416818015585`*^9, 3.574241724639234*^9, 
  3.577284953795015*^9, 3.5773451040316286`*^9, 3.5817466970522523`*^9, 
  3.586414911869149*^9, 3.586731353438407*^9, 3.586731745841496*^9, 
  3.5869898081507463`*^9, 3.5908108354636354`*^9, 3.5908245393883405`*^9, 
  3.5909019668141804`*^9, 3.5909100389260225`*^9, 3.5944856668567314`*^9, 
  3.5944857952360744`*^9, 3.594485852616356*^9, 3.5944867717499275`*^9, 
  3.5944868684654593`*^9, 3.594486968763196*^9, 3.5944870923122625`*^9, 
  3.59448740749229*^9, 3.59449080469645*^9, 3.5945251898234406`*^9, 
  3.602330992263464*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", "M"}], 
  SuperscriptBox["\[ScriptR]", "4"]]], "Output",
 CellChangeTimes->{3.572105344136012*^9, 3.5721055412267585`*^9, 
  3.572544753102059*^9, 3.5725465770643835`*^9, 3.5736771808071594`*^9, 
  3.5742001088533883`*^9, 3.5742416818015585`*^9, 3.574241724639234*^9, 
  3.577284953795015*^9, 3.5773451040316286`*^9, 3.5817466970522523`*^9, 
  3.586414911869149*^9, 3.586731353438407*^9, 3.586731745841496*^9, 
  3.5869898081507463`*^9, 3.5908108354636354`*^9, 3.5908245393883405`*^9, 
  3.5909019668141804`*^9, 3.5909100389260225`*^9, 3.5944856668567314`*^9, 
  3.5944857952360744`*^9, 3.594485852616356*^9, 3.5944867717499275`*^9, 
  3.5944868684654593`*^9, 3.594486968763196*^9, 3.5944870923122625`*^9, 
  3.59448740749229*^9, 3.59449080469645*^9, 3.5945251898234406`*^9, 
  3.602330992283464*^9}]
}, Open  ]],

Cell[TextData[{
 "The list of cached tensor components can be displayed by ",
 StyleBox["cacheview",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{3.573665555267704*^9, 3.574848474082854*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cacheview", "[", "tRicciR", "]"}]], "Input",
 CellChangeTimes->{3.5748484766568584`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"tRicciR", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.5721053443700123`*^9, 3.572105541476359*^9, 
  3.5725447532850695`*^9, 3.572546577536411*^9, 3.57367718105676*^9, 
  3.5742001090561886`*^9, 3.574241681973159*^9, 3.5742417248576345`*^9, 
  3.577284953966615*^9, 3.577345104218829*^9, 3.5817466972550526`*^9, 
  3.58641491210315*^9, 3.586731353750407*^9, 3.5867317460442963`*^9, 
  3.5869898084159465`*^9, 3.5908108360408363`*^9, 3.590824540183942*^9, 
  3.5909019673913813`*^9, 3.5909100397528243`*^9, 3.5944856671607485`*^9, 
  3.594485795968116*^9, 3.594485852789366*^9, 3.5944867721139483`*^9, 
  3.594486869018491*^9, 3.594486969039212*^9, 3.5944870927952905`*^9, 
  3.5944874081833296`*^9, 3.5944908052324805`*^9, 3.5945251902724657`*^9, 
  3.6023309922934637`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cacheview", "[", "tRiemannR", "]"}]], "Input",
 CellChangeTimes->{3.5748484776240597`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4"}], ",", "1", ",", "4", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "1", ",", "3", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1", ",", "2", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5721053445416126`*^9, 3.572105541632359*^9, 
  3.572544753701093*^9, 3.572546577746423*^9, 3.57367718121276*^9, 
  3.574200109227789*^9, 3.574241682175959*^9, 3.5742417250136347`*^9, 
  3.5772849541226153`*^9, 3.57734510470243*^9, 3.581746697660653*^9, 
  3.5864149122747498`*^9, 3.586731354109208*^9, 3.5867317461846967`*^9, 
  3.586989808571947*^9, 3.590810836898838*^9, 3.590824540995143*^9, 
  3.590901968296183*^9, 3.590910041110027*^9, 3.5944856678737893`*^9, 
  3.594485796142126*^9, 3.594485852941375*^9, 3.5944867725379725`*^9, 
  3.5944868691735*^9, 3.594486969202221*^9, 3.5944870929502993`*^9, 
  3.5944874083873415`*^9, 3.594490805420491*^9, 3.594525190437475*^9, 
  3.602330992313464*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"cacheview", "[", 
  RowBox[{"covariantD", "[", "tRiemannR", "]"}], "]"}]], "Input",
 CellChangeTimes->{3.5748484785756617`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"covariantD", "[", "tRiemannR", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], "}"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5721053449160137`*^9, 3.57210554202236*^9, 
  3.572544753873103*^9, 3.572546577951434*^9, 3.57367718158716*^9, 
  3.5742001096333895`*^9, 3.5742416823787594`*^9, 3.5742417253880353`*^9, 
  3.577284954528216*^9, 3.57734510488963*^9, 3.5817466978478537`*^9, 
  3.586414912680351*^9, 3.5867313542808084`*^9, 3.586731746340697*^9, 
  3.586989808946347*^9, 3.590810837522839*^9, 3.590824541556744*^9, 
  3.590901968920184*^9, 3.5909100420928288`*^9, 3.5944856683188148`*^9, 
  3.594485796287134*^9, 3.594485853091383*^9, 3.5944867726859813`*^9, 
  3.5944868693305087`*^9, 3.5944869693692307`*^9, 3.5944870931463103`*^9, 
  3.594487408579352*^9, 3.59449080574751*^9, 3.594525190596484*^9, 
  3.6023309923334637`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Displaying all associated values (",
 StyleBox["associated",
  FontSlant->"Italic"],
 ")"
}], "Subsection",
 CellChangeTimes->{3.5722725363125715`*^9}],

Cell[TextData[{
 StyleBox[" associated[symbol]",
  FontSlant->"Italic"],
 " displays all ",
 "cached",
 " quantities associated with the specified symbol (either function name or \
argument)"
}], "Text",
 CellChangeTimes->{
  3.573665557311308*^9, {3.573759405260744*^9, 3.573759427521983*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"associated", "[", "tRiemannR", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "4"}], ",", "1", ",", "4", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "1", ",", "3", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "1", ",", "2", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "2", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "3", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "4", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"tRiemannR", ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2", ",", "1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "tRiemannR", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], "}"}]}], "}"}]}],
   "}"}]], "Output",
 CellChangeTimes->{3.5721053466164165`*^9, 3.5721055435199623`*^9, 
  3.572544755420192*^9, 3.5725465795745273`*^9, 3.573677183178363*^9, 
  3.574200111006192*^9, 3.5742416844379635`*^9, 3.574241726870038*^9, 
  3.577284955994619*^9, 3.577345106621233*^9, 3.5817466996106567`*^9, 
  3.5864149148019543`*^9, 3.5867313560904117`*^9, 3.5867317481503*^9, 
  3.5869898104439497`*^9, 3.5908108520776644`*^9, 3.590824554551567*^9, 
  3.590901981946207*^9, 3.5909100544636497`*^9, 3.5944856689218493`*^9, 
  3.5944857968021636`*^9, 3.5944858535054073`*^9, 3.594486773054002*^9, 
  3.594486869685529*^9, 3.5944869700652704`*^9, 3.5944870936013365`*^9, 
  3.594487409089381*^9, 3.594490806118531*^9, 3.5945251909665055`*^9, 
  3.6023309924834642`*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Clearing the cache content", "Section",
 CellChangeTimes->{{3.5748480616649294`*^9, 3.5748480631937323`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Tensor definition alternations during the current session (",
 StyleBox["retreat",
  FontSlant->"Italic"],
 ")"
}], "Subsection",
 CellChangeTimes->{3.572272543566584*^9}],

Cell[TextData[{
 "If some redefinitions of ",
 StyleBox["expr",
  FontSlant->"Italic"],
 " are indispensable use",
 StyleBox[" retreat",
  FontSlant->"Italic"],
 "  to remove associated values of  h\[DoubleDagger] ,  \[Chi]\[DoubleDagger] \
, LieD, etc. ",
 StyleBox["retreat",
  FontSlant->"Italic"],
 " clears out cached values but preserve the background definition (results \
of ",
 StyleBox["retreat",
  FontSlant->"Italic"],
 " are opposite to that of Unset):"
}], "Text",
 CellChangeTimes->{
  3.5722726108495026`*^9, 3.573665561991316*^9, {3.573759481045677*^9, 
   3.5737594909516945`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ncov", "[", "m_", "]"}], ":=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], "[", 
   RowBox[{"[", "m", "]"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "m_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"unitvector", "[", "ncov", "]"}], "[", "m", "]"}], "//", 
     "Simplify"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Outer", "[", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", "all", ",", "all"}], "]"}], "//",
    "Simplify"}], "//", "MatrixForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"M", " ", 
       SqrtBox[
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", "M"}], "-", "\[ScriptR]"}], 
         SuperscriptBox["\[ScriptR]", "5"]]]}], "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", 
      RowBox[{"-", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "M"}], "-", "\[ScriptR]"}], ")"}], " ", 
         "\[ScriptR]"}]]}], "0"},
     {"0", "0", "0", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", "M"}], "-", "\[ScriptR]"}], ")"}], " ", 
          "\[ScriptR]"}]]}], " ", 
       SuperscriptBox[
        RowBox[{"Sin", "[", "\[CurlyTheta]", "]"}], "2"]}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5721053477864184`*^9, 3.5721055447055645`*^9, 
  3.5725447567922697`*^9, 3.572546581070613*^9, 3.573677184660366*^9, 
  3.574200112597395*^9, 3.5742416858107653`*^9, 3.57424172805564*^9, 
  3.5772849572582207`*^9, 3.5773451079940352`*^9, 3.581746700874259*^9, 
  3.586414916393157*^9, 3.5867313566208124`*^9, 3.586731748571501*^9, 
  3.586989810927551*^9, 3.5908108536220675`*^9, 3.5908245559555693`*^9, 
  3.5909019833346095`*^9, 3.5909100558988523`*^9, 3.5944856706889505`*^9, 
  3.5944857988272796`*^9, 3.5944858546024694`*^9, 3.5944867745440874`*^9, 
  3.5944868712496185`*^9, 3.594486971434349*^9, 3.5944870951604257`*^9, 
  3.5944874104954615`*^9, 3.594490807727623*^9, 3.594525192481592*^9, 
  3.602330992773465*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"associated", "[", "n", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5721053494868217`*^9, 3.5721055463903675`*^9, 
  3.572544758484367*^9, 3.5725465829017177`*^9, 3.5736771864387693`*^9, 
  3.5742001142353983`*^9, 3.5742416879011693`*^9, 3.574241729709243*^9, 
  3.5772849588650236`*^9, 3.5773451097256384`*^9, 3.5817467028710623`*^9, 
  3.586414918530361*^9, 3.586731358134015*^9, 3.586731750193904*^9, 
  3.586989812300353*^9, 3.590810866039689*^9, 3.5908245683419914`*^9, 
  3.5909019959082317`*^9, 3.590910069190076*^9, 3.5944856714719954`*^9, 
  3.5944857994243135`*^9, 3.594485855176502*^9, 3.594486775343133*^9, 
  3.5944868718226514`*^9, 3.594486972013382*^9, 3.594487095726458*^9, 
  3.5944874111484995`*^9, 3.594490808280655*^9, 3.594525193055625*^9, 
  3.6023309928334646`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"retreat", "[", 
   RowBox[{"n", ",", "associated"}], "]"}], ";"}], "\n", 
 RowBox[{"associated", "[", "n", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.572105352435227*^9, 3.5721055493855724`*^9, 
  3.572544761495539*^9, 3.572546585656875*^9, 3.573677189621175*^9, 
  3.5742001168406024`*^9, 3.5742416920507765`*^9, 3.5742417325952477`*^9, 
  3.577284962047429*^9, 3.577345112486843*^9, 3.581746706115868*^9, 
  3.586414922040367*^9, 3.5867313613944206`*^9, 3.5867317535323095`*^9, 
  3.5869898151239586`*^9, 3.5908108906721325`*^9, 3.590824594222437*^9, 
  3.590902020103874*^9, 3.590910096084523*^9, 3.594485672027027*^9, 
  3.5944858000683503`*^9, 3.5944858556775312`*^9, 3.594486776404194*^9, 
  3.5944868723796835`*^9, 3.5944869725634136`*^9, 3.5944870962764893`*^9, 
  3.5944874117415333`*^9, 3.594490808838687*^9, 3.5945251936626596`*^9, 
  3.6023309929634647`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ncov", "[", "m_", "]"}], ":=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], "[", 
    RowBox[{"[", "m", "]"}], "]"}]}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"alternative", " ", "definition"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"n", "[", "m_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"unitvector", "[", "ncov", "]"}], "[", "m", "]"}], "//", 
     "Simplify"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Outer", "[", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", "all", ",", "all"}], "]"}], "//",
    "Simplify"}], "//", "MatrixForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0"},
     {
      FractionBox["M", 
       SqrtBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "M"}], "-", "\[ScriptR]"}], ")"}], " ", 
         SuperscriptBox["\[ScriptR]", "3"]}]]], "0", "0", "0"},
     {"0", "0", "0", "0"},
     {"0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.572105353839229*^9, 3.5721055509923754`*^9, 
  3.5725447629736233`*^9, 3.572546587107958*^9, 3.573677190884777*^9, 
  3.574200118119805*^9, 3.574241693376779*^9, 3.57424173412405*^9, 
  3.577284963357832*^9, 3.5773451138284454`*^9, 3.5817467075198708`*^9, 
  3.58641492350677*^9, 3.586731361956022*^9, 3.5867317541251106`*^9, 
  3.586989815732359*^9, 3.590810892029335*^9, 3.590824595626439*^9, 
  3.5909020215078764`*^9, 3.590910097535326*^9, 3.5944856735641146`*^9, 
  3.594485801856453*^9, 3.594485857126614*^9, 3.5944867768042164`*^9, 
  3.5944868740257773`*^9, 3.594486974100501*^9, 3.5944870979695864`*^9, 
  3.594487413511634*^9, 3.5944908103947763`*^9, 3.5945251952797527`*^9, 
  3.602330993233465*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"associated", "[", "n", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"covariantD", "[", "n", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.5944858577496495`*^9, 3.5944867771132345`*^9, 
  3.594486874613811*^9, 3.594486974681535*^9, 3.594487098545619*^9, 
  3.594487414164672*^9, 3.5944908109558077`*^9, 3.594525195814783*^9, 
  3.6023309932934656`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"retreat", "[", 
   RowBox[{"n", ",", "associated"}], "]"}], ";"}], "\n", 
 RowBox[{"associated", "[", "n", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.572105356974835*^9, 3.572105553971981*^9, 
  3.572544765798785*^9, 3.5725465899781227`*^9, 3.5736771940047827`*^9, 
  3.5742001207562094`*^9, 3.5742416970895853`*^9, 3.5742417370724554`*^9, 
  3.5772849661814365`*^9, 3.57734511666765*^9, 3.5817467107802763`*^9, 
  3.586414927094776*^9, 3.5867313650448275`*^9, 3.5867317571359158`*^9, 
  3.586989818493564*^9, 3.5908109176601796`*^9, 3.5908246208984833`*^9, 
  3.59090204623392*^9, 3.5909101234781713`*^9, 3.594485674861189*^9, 
  3.594485802610496*^9, 3.594485858340684*^9, 3.5944867776272635`*^9, 
  3.5944868753658543`*^9, 3.5944869751815634`*^9, 3.5944870990426474`*^9, 
  3.594487414678701*^9, 3.5944908114898386`*^9, 3.594525196350814*^9, 
  3.6023309933934655`*^9}]
}, Open  ]],

Cell[TextData[{
 "Command",
 StyleBox[" retreat",
  FontSlant->"Italic"],
 " is dedicated to occasional use, and shall be removed from the final \
version of notebook. ",
 StyleBox["retreat",
  FontSlant->"Italic"],
 " will always slow down the computation process!"
}], "Text",
 CellChangeTimes->{3.5722726223311224`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Metrics alternations", "Subsection"],

Cell[TextData[{
 "Tensors defined in the Package are automatically appended to ",
 StyleBox["memRegistry.",
  FontSlant->"Italic"],
 " These tensors are cleared whenever metrics changes  (see section ",
 Cell[BoxData[
  ButtonBox[
   PaneSelectorBox[{False->
    StyleBox["\<\"Opening procedure\"\>", "Hyperlink",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12], True->
    StyleBox["\<\"Opening procedure\"\>", "HyperlinkActive",
     StripOnInput->False,
     FontFamily->"Candara",
     FontSize->12]}, Dynamic[
     CurrentValue["MouseOver"]],
    FrameMargins->0,
    ImageSize->Automatic],
   Appearance->None,
   ButtonFunction:>
    Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = \
{WindowSize -> {
          Scaled[3/4], 
          Scaled[1]}, 
        WindowMargins -> {{Automatic, 0}, {
          Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
         NotebookDirectory[], "opening.nb"}]; 
     NotebookOpen[$CellContext`fullname$, 
       Apply[Sequence, $CellContext`stan$]]],
   Evaluator->Automatic,
   Method->"Preemptive"]],
  CellChangeTimes->{3.5690888125894556`*^9}],
 ")."
}], "Text",
 CellChangeTimes->{3.5721053185363674`*^9, 3.573665764869672*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {3.5689765261927013`*^9}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {3.568976573569985*^9}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {3.5689765583287582`*^9}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {3.568981227090465*^9}, FontFamily -> "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {3.5689812390088863`*^9}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", CellChangeTimes -> {3.568980449396245*^9}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 35, 0, 76, "Title"],
Cell[CellGroupData[{
Cell[640, 26, 34, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[699, 30, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[753, 34, 111, 3, 65, "Input"],
Cell[867, 39, 403, 8, 70, "Print"],
Cell[1273, 49, 883, 14, 70, "Output"]
}, Open  ]],
Cell[2171, 66, 652, 18, 28, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[2860, 89, 49, 0, 25, "Subsection"],
Cell[CellGroupData[{
Cell[2934, 93, 39, 0, 44, "Input"],
Cell[2976, 95, 2285, 55, 70, "Output"]
}, Open  ]],
Cell[5276, 153, 137, 4, 44, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[5462, 163, 113, 1, 38, "Section"],
Cell[CellGroupData[{
Cell[5600, 168, 110, 1, 31, "Subsection"],
Cell[5713, 171, 546, 12, 45, "Text"],
Cell[6262, 185, 110, 1, 28, "Text"],
Cell[6375, 188, 185, 6, 44, "Input"],
Cell[6563, 196, 18, 0, 28, "Text"],
Cell[6584, 198, 271, 9, 44, "Input"],
Cell[6858, 209, 1253, 20, 45, "Text"],
Cell[8114, 231, 415, 7, 28, "Text"],
Cell[8532, 240, 382, 8, 45, "Text"],
Cell[8917, 250, 566, 9, 45, "Text"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9532, 265, 37, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[9594, 269, 252, 8, 31, "Subsection"],
Cell[9849, 279, 1108, 25, 79, "Text"],
Cell[CellGroupData[{
Cell[10982, 308, 186, 3, 65, "Input"],
Cell[11171, 313, 1411, 22, 70, "Output"]
}, Open  ]],
Cell[12597, 338, 2318, 41, 62, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[14952, 384, 248, 8, 25, "Subsection"],
Cell[CellGroupData[{
Cell[15225, 396, 221, 5, 65, "Input"],
Cell[15449, 403, 772, 11, 31, "Output"],
Cell[16224, 416, 848, 14, 47, "Output"]
}, Open  ]],
Cell[17087, 433, 199, 5, 28, "Text"],
Cell[CellGroupData[{
Cell[17311, 442, 112, 2, 44, "Input"],
Cell[17426, 446, 896, 16, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18359, 467, 114, 2, 44, "Input"],
Cell[18476, 471, 3268, 90, 112, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21781, 566, 151, 3, 44, "Input"],
Cell[21935, 571, 960, 18, 31, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22944, 595, 169, 6, 31, "Subsection"],
Cell[23116, 603, 294, 9, 28, "Text"],
Cell[CellGroupData[{
Cell[23435, 616, 71, 1, 44, "Input"],
Cell[23509, 619, 3476, 95, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27046, 721, 115, 1, 46, "Section"],
Cell[CellGroupData[{
Cell[27186, 726, 189, 6, 31, "Subsection"],
Cell[27378, 734, 599, 19, 45, "Text"],
Cell[CellGroupData[{
Cell[28002, 757, 612, 20, 105, "Input"],
Cell[28617, 779, 2074, 53, 128, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30728, 837, 63, 1, 44, "Input"],
Cell[30794, 840, 3227, 93, 92, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34058, 938, 160, 4, 65, "Input"],
Cell[34221, 944, 787, 12, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35045, 961, 718, 23, 105, "Input"],
Cell[35766, 986, 1604, 37, 104, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37407, 1028, 63, 1, 44, "Input"],
Cell[37473, 1031, 2720, 86, 92, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40230, 1122, 160, 4, 65, "Input"],
Cell[40393, 1128, 789, 12, 31, "Output"]
}, Open  ]],
Cell[41197, 1143, 322, 10, 28, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41556, 1158, 42, 0, 31, "Subsection"],
Cell[41601, 1160, 1234, 35, 29, "Text"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
