(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     63078,       1808]
NotebookOptionsPosition[     54378,       1565]
NotebookOutlinePosition[     59989,       1697]
CellTagsIndexPosition[     59819,       1690]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Riemann tensor (examples)", "Title",
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Package", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\n", "version"}], "Input"],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.57210668676797*^9, 3.591482487039796*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Tue 22 Oct 2013 20:56:29\"\>", ",", 
   "51248"}], "}"}]], "Output",
 CellChangeTimes->{3.5721065813897853`*^9, 3.572106616833048*^9, 
  3.5721066868615704`*^9, 3.5914824871489954`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Coordinates and the metric tensor", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", "K", "]"}], ";", 
  RowBox[{"K", "==", "0"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData["Friedman"], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "0", "0", "0"},
         {"0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0", "0"},
         {"0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0"},
         {"0", "0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.5721065837609897`*^9, 3.5721066184242506`*^9, 
  3.572106689170375*^9, 3.5914824913922033`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Riemann tensor", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "tRiemannR"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Riemann tensor: \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,j,m,n] \
= \!\(\*SubscriptBox[\(R\), \(ijmn\)]\), \\n\t\!\(\*\\nStyleBox[\\\"tRiemannR\
\\\",\\nFontSlant->\\\"Italic\\\"]\)[-i, j,m,n] = \
\!\(\*SubscriptBox[SuperscriptBox[\(R\), \(i\)], \(jmn\)]\),   \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,-j, \
m,n] = \!\(\*SubscriptBox[SuperscriptBox[SubscriptBox[\(R\), \(i\)], \(j\)], \
\(mn\)]\), ...\\n\t\
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[-i,-j,m,n]\
 = \!\(\*SubscriptBox[SuperscriptBox[\(R\), \(ij\)], \(mn\)]\),  \
\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\"Italic\\\"]\)[i,-j,-m,n]\
 = \!\(\*SubscriptBox[SuperscriptBox[SubscriptBox[\(R\), \(i\)], \(jm\)], \(n\
\)]\), ...\\n\t(...)\\n\t\!\(\*\\nStyleBox[\\\"tRiemannR\\\",\\nFontSlant->\\\
\"Italic\\\"]\)[-i,-j,-m,-n] = \!\(\*SuperscriptBox[\(R\), \(ijmn\)]\) \"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5914824926558056`*^9},
 CellTags->"Info3591489692-4955531"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Riemann tensor components", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tRiemannR", "[", 
   RowBox[{"1", ",", "4", ",", 
    RowBox[{"-", "1"}], ",", "4"}], "]"}], "//", "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01599999999999987`", ",", 
   FractionBox[
    RowBox[{"16", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "+", 
       RowBox[{
        RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
        RowBox[{
         SuperscriptBox["a", "\[Prime]\[Prime]",
          MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"4", "+", 
        RowBox[{"K", " ", 
         SuperscriptBox["\[ScriptX]", "2"]}], "+", 
        RowBox[{"K", " ", 
         SuperscriptBox["\[ScriptY]", "2"]}], "+", 
        RowBox[{"K", " ", 
         SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.5721065847281914`*^9, 3.572106619188652*^9, 
  3.5721066900595765`*^9, 3.5914824934358068`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tRiemannR", "[", 
   RowBox[{
    RowBox[{"-", "2"}], ",", "4", ",", "2", ",", 
    RowBox[{"-", "4"}]}], "]"}], "//", "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.015999999999999952`", ",", 
   FractionBox[
    RowBox[{
     RowBox[{"K", " ", 
      SuperscriptBox[
       RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
     SuperscriptBox[
      RowBox[{
       SuperscriptBox["a", "\[Prime]",
        MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
    SuperscriptBox[
     RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}], "}"}]], "Output",
 CellChangeTimes->{3.572106584915392*^9, 3.572106619313452*^9, 
  3.5721066901843767`*^9, 3.591482493591807*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["verifying identities", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "verify"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"\!\(\*\\nStyleBox[\\\"verify\\\",\\nFontSlant->\\\"Italic\\\"]\
\)[identity_,indexes__]:=Timing[DeleteDuplicates[Flatten[Simplify[Outer[\
identity,indexes]]]]]\\n\\n\!\(\*\\nStyleBox[\\\"verify\\\",\\nFontSlant->\\\"\
Italic\\\"]\) attempts to checks whether identity is true or false for \
specified list of indexes. \"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.591482494059808*^9},
 CellTags->"Info3591489693-4955531"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"id", "[", 
     RowBox[{"k_", ",", "i_", ",", "j_", ",", "l_"}], "]"}], ":=", "     ", 
    "\n", "\n", "\t\t", 
    RowBox[{
     RowBox[{
      RowBox[{"tRiemannR", "[", 
       RowBox[{
        RowBox[{"-", "k"}], ",", "i", ",", "j", ",", "l"}], "]"}], "+", 
      RowBox[{"tRiemannR", "[", 
       RowBox[{
        RowBox[{"-", "k"}], ",", "l", ",", "i", ",", "j"}], "]"}], "+", 
      RowBox[{"tRiemannR", "[", 
       RowBox[{
        RowBox[{"-", "k"}], ",", "j", ",", "l", ",", "i"}], "]"}]}], "==", 
     "0"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"verify", "[", 
   RowBox[{"id", ",", "all", ",", "all", ",", "all", ",", "all"}], "]"}], 
  "             "}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.17`", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.572106586880995*^9, 3.572106620077853*^9, 
  3.572106691822379*^9, 3.591482495869411*^9}]
}, Open  ]],

Cell["Bianchi identity:", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Bianchi", "[", 
   RowBox[{"s_", ",", "r_", ",", "i_", ",", "j_", ",", "k_"}], "]"}], ":=", 
  "\n", "     ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "s"}], ",", "r", ",", "i", ",", "j"}], "}"}], ",", "k"}],
      "]"}], "+", "\n", "     ", 
    RowBox[{
     RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "s"}], ",", "r", ",", "j", ",", "k"}], "}"}], ",", "i"}],
      "]"}], "+", "\n", "     ", 
    RowBox[{
     RowBox[{"covariantD", "[", "tRiemannR", "]"}], "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "s"}], ",", "r", ",", "k", ",", "i"}], "}"}], ",", "j"}],
      "]"}]}], "==", "0"}]}]], "Input",
 CellChangeTimes->{{3.5721066481423025`*^9, 3.572106654101513*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Bianchi", "@@", 
    RowBox[{"Flatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"RandomSample", "[", 
        RowBox[{"all", ",", "2"}], "]"}], ",", 
       RowBox[{"RandomSample", "[", 
        RowBox[{"all", ",", "3"}], "]"}]}], "}"}], "]"}]}], "//", 
   "Simplify"}], "//", "Timing"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.17199999999999996`", ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{3.5721065874581957`*^9, 3.572106620421054*^9, 
  3.5721066923683805`*^9, 3.591482496446612*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["contracting Riemann tensor", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "tRicciR"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Ricci tensor:  \
\!\(\*\\nStyleBox[\\\"tRicciR\\\",\\nFontSlant->\\\"Italic\\\"]\)[m, n] = \
\!\(\*SubscriptBox[\(R\), \(mn\)]\), \
\!\(\*\\nStyleBox[\\\"tRicciR\\\",\\nFontSlant->\\\"Italic\\\"]\)[-m,-n] = \!\
\(\*SuperscriptBox[\(R\), \(mn\)]\), \
\!\(\*\\nStyleBox[\\\"tRicciR\\\",\\nFontSlant->\\\"Italic\\\"]\)[m,-n] = \
\!\(\*SuperscriptBox[SubscriptBox[\(R\), \(m\)], \(n\)]\)\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5914824968210125`*^9},
 CellTags->"Info3591489696-7911430"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"id1", "[", 
     RowBox[{"m_", ",", "n_"}], "]"}], ":=", "\n", "\n", "\t\t", 
    RowBox[{
     RowBox[{"tRicciR", "[", 
      RowBox[{"m", ",", "n"}], "]"}], "==", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", "q", "dim"], 
      RowBox[{"tRiemannR", "[", 
       RowBox[{"m", ",", 
        RowBox[{"-", "q"}], ",", "n", ",", "q"}], "]"}]}]}]}], ";"}], 
  "\n"}], "\n", 
 RowBox[{
  RowBox[{"verify", "[", 
   RowBox[{"id1", ",", "all", ",", "all"}], "]"}], "     "}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.7329999999999999`", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.572106588877798*^9, 3.5721066214350557`*^9, 
  3.5721066941311836`*^9, 3.591482498115815*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["matrix forms", "Subsection"],

Cell["Using Outer (system command)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Outer", "[", 
   RowBox[{"tRiemannR", ",", "all", ",", "all", ",", "all", ",", "all"}], 
   "]"}], "//", "MF"}]], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]], "0", "0"},
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}], "0", 
          "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", 
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]], "0"},
         {"0", "0", "0", "0"},
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}], "0", 
          "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", 
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}], "0", 
          "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}], "0", 
          "0"},
         {
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]], "0", "0", 
          "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]], "0"},
         {"0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}], "0", 
          "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]},
         {"0", "0", "0", "0"},
         {"0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}], "0", 
          "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}], "0"},
         {"0", "0", "0", "0"},
         {
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]], "0", "0", 
          "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}], "0"},
         {"0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]], "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]},
         {"0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}], "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]},
     {
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"16", " ", 
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
               RowBox[{
                RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
                RowBox[{
                 SuperscriptBox["a", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]]}]},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "-", 
              RowBox[{
               RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
               RowBox[{
                SuperscriptBox["a", "\[Prime]\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "2"]], "0", "0", 
          "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}]},
         {"0", "0", "0", "0"},
         {"0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]], "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"256", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"K", " ", 
                SuperscriptBox[
                 RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
               SuperscriptBox[
                RowBox[{
                 SuperscriptBox["a", "\[Prime]",
                  MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
              ")"}]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptX]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptY]", "2"]}], "+", 
               RowBox[{"K", " ", 
                SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]]}]},
         {"0", "0", 
          FractionBox[
           RowBox[{"256", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"K", " ", 
               SuperscriptBox[
                RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
              SuperscriptBox[
               RowBox[{
                SuperscriptBox["a", "\[Prime]",
                 MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], 
             ")"}]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptX]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptY]", "2"]}], "+", 
              RowBox[{"K", " ", 
               SuperscriptBox["\[ScriptZ]", "2"]}]}], ")"}], "4"]], "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"},
         {"0", "0", "0", "0"}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5721065895797997`*^9, 3.5721066216222563`*^9, 
  3.572106694989185*^9, 3.591482499207817*^9}]
}, Open  ]],

Cell["Using  tabular", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RR", "=", 
    RowBox[{"tabular", "[", "tRicciR", "]"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"RR", "[", 
   RowBox[{"all", ",", 
    RowBox[{"-", "all"}]}], "]"}], "//", "MF"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      FractionBox[
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{
             SuperscriptBox["a", "\[Prime]",
              MultilineFunction->None], "[", "\[Eta]", "]"}], "2"]}], "+", 
          RowBox[{
           RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
           RowBox[{
            SuperscriptBox["a", "\[Prime]\[Prime]",
             MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], ")"}]}], 
       SuperscriptBox[
        RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "0", "0", "0"},
     {"0", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "K", " ", 
         SuperscriptBox[
          RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "+", 
        RowBox[{
         RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
       SuperscriptBox[
        RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "0", "0"},
     {"0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "K", " ", 
         SuperscriptBox[
          RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "+", 
        RowBox[{
         RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
       SuperscriptBox[
        RowBox[{"a", "[", "\[Eta]", "]"}], "4"]], "0"},
     {"0", "0", "0", 
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "K", " ", 
         SuperscriptBox[
          RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "+", 
        SuperscriptBox[
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], "2"], "+", 
        RowBox[{
         RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}]}]}], 
       SuperscriptBox[
        RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.572106590125801*^9, 3.5721066219186563`*^9, 
  3.5721066952543855`*^9, 3.591482499785018*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"gg", "=", 
    RowBox[{"tabular", "[", "metricExt", "]"}]}], ";"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"gg", "[", 
   RowBox[{"all", ",", 
    RowBox[{"-", "all"}]}], "]"}], "//", "MF"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", "0", "0"},
     {"0", "1", "0", "0"},
     {"0", "0", "1", "0"},
     {"0", "0", "0", "1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.572106590250601*^9, 3.5721066220902567`*^9, 
  3.5721066958003864`*^9, 3.5914824999722185`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"gg", "[", 
     RowBox[{"all", ",", "all"}], "]"}], ".", 
    RowBox[{"RR", "[", 
     RowBox[{
      RowBox[{"-", "all"}], ",", 
      RowBox[{"-", "all"}]}], "]"}]}], "//", "Tr"}], "//", 
  "Simplify"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"K", " ", 
      RowBox[{"a", "[", "\[Eta]", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["a", "\[Prime]\[Prime]",
       MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}], 
  SuperscriptBox[
   RowBox[{"a", "[", "\[Eta]", "]"}], "3"]]], "Output",
 CellChangeTimes->{3.5721065904690013`*^9, 3.572106622261857*^9, 
  3.572106696065587*^9, 3.591482500237419*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["covariant derivative commutators", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"v", "[", "i_", "]"}], ":=", 
   RowBox[{
    RowBox[{"v", "[", "i", "]"}], "=", 
    RowBox[{
     RowBox[{"covariantD", "[", "sRicciR", "]"}], "[", "i", "]"}]}]}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"sample", " ", "vector"}], " ", "*)"}], "\n"}], "\n", 
 RowBox[{
  RowBox[{"v", "/@", "all"}], "//", "Simplify"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"6", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}], " ", 
         RowBox[{
          SuperscriptBox["a", "\[Prime]\[Prime]",
           MultilineFunction->None], "[", "\[Eta]", "]"}]}], "+", 
        RowBox[{
         RowBox[{"a", "[", "\[Eta]", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "K", " ", 
            RowBox[{
             SuperscriptBox["a", "\[Prime]",
              MultilineFunction->None], "[", "\[Eta]", "]"}]}], "-", 
           RowBox[{
            SuperscriptBox["a", 
             TagBox[
              RowBox[{"(", "3", ")"}],
              Derivative],
             MultilineFunction->None], "[", "\[Eta]", "]"}]}], ")"}]}]}], 
       ")"}]}], 
     SuperscriptBox[
      RowBox[{"a", "[", "\[Eta]", "]"}], "4"]]}], ",", "0", ",", "0", ",", 
   "0"}], "}"}]], "Output",
 CellChangeTimes->{3.572106590687402*^9, 3.5721066225114574`*^9, 
  3.5721066963931875`*^9, 3.591482500596219*^9}]
}, Open  ]],

Cell["Commutator 1.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"id2", "[", 
    RowBox[{"r_", ",", "m_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"id2", "[", 
     RowBox[{"r", ",", "m", ",", "n"}], "]"}], "=", "\n", "\n", "\t\t", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[EmptyDownTriangle]", "[", "v", "]"}], "[", 
       RowBox[{"r", ",", "m", ",", "n"}], "]"}], "-", 
      RowBox[{
       RowBox[{"\[EmptyDownTriangle]", "[", "v", "]"}], "[", 
       RowBox[{"r", ",", "n", ",", "m"}], "]"}]}], "==", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", "s", "all"], 
      RowBox[{
       RowBox[{"tRiemannR", "[", 
        RowBox[{
         RowBox[{"-", "s"}], ",", "r", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{"v", "[", "s", "]"}]}]}]}]}]}], "\n"}], "\n", 
 RowBox[{"verify", "[", 
  RowBox[{"id2", ",", "all", ",", "all", ",", "all"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15.693999999999999`", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.572106605866228*^9, 3.5721066227922583`*^9}, 
   3.5721067117592144`*^9, 3.5914825167422476`*^9}]
}, Open  ]],

Cell["Commutator 2 . ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"R", "=", "sRicciR"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"id4", "[", 
    RowBox[{"r_", ",", "m_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"id4", "[", 
     RowBox[{"r", ",", "m", ",", "n"}], "]"}], "=", "\n", "\n", "\t\t", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"\[EmptyDownTriangle]", "[", "R", "]"}], "[", 
       RowBox[{"r", ",", "m", ",", "n"}], "]"}], "-", 
      RowBox[{
       RowBox[{"\[EmptyDownTriangle]", "[", "R", "]"}], "[", 
       RowBox[{"r", ",", "n", ",", "m"}], "]"}]}], "==", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"s", "=", "1"}], "dim"], 
      RowBox[{
       RowBox[{"tRiemannR", "[", 
        RowBox[{
         RowBox[{"-", "s"}], ",", "r", ",", "m", ",", "n"}], "]"}], " ", 
       RowBox[{
        RowBox[{"\[EmptyDownTriangle]", "[", "R", "]"}], "[", "s", 
        "]"}]}]}]}]}]}], "\n"}], "\n", 
 RowBox[{"verify", "[", 
  RowBox[{"id4", ",", "all", ",", "all", ",", "all"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"5.927999999999999`", ",", 
   RowBox[{"{", "True", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.572106611981439*^9, 3.5721066230418587`*^9}, 
   3.5721067175624247`*^9, 3.5914825231070585`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[" ", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeUsed", "[", "]"}]], "Input"],

Cell[BoxData["28.817`"], "Output",
 CellChangeTimes->{{3.5721066123402395`*^9, 3.57210662385306*^9}, 
   3.572106717890025*^9, 3.59148252349706*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{760, 500},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {3.5689765261927013`*^9}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {3.568976573569985*^9}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {3.5689765583287582`*^9}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {3.568981227090465*^9}, FontFamily -> "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {3.5689812390088863`*^9}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", CellChangeTimes -> {3.568980449396245*^9}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "8.0 for Microsoft Windows (32-bit) (October 6, 2011)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3591489692-4955531"->{
  Cell[4616, 155, 1076, 17, 125, "Print",
   CellTags->"Info3591489692-4955531"]},
 "Info3591489693-4955531"->{
  Cell[7957, 258, 464, 7, 75, "Print",
   CellTags->"Info3591489693-4955531"]},
 "Info3591489696-7911430"->{
  Cell[11192, 366, 534, 10, 42, "Print",
   CellTags->"Info3591489696-7911430"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3591489692-4955531", 59493, 1678},
 {"Info3591489693-4955531", 59605, 1681},
 {"Info3591489696-7911430", 59714, 1684}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 70, 1, 76, "Title"],
Cell[CellGroupData[{
Cell[675, 27, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[729, 31, 111, 3, 65, "Input"],
Cell[843, 36, 254, 6, 23, "Print"],
Cell[1100, 44, 254, 5, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1403, 55, 55, 0, 31, "Subsection"],
Cell[1461, 57, 110, 3, 44, "Input"],
Cell[CellGroupData[{
Cell[1596, 64, 34, 0, 44, "Input"],
Cell[1633, 66, 2818, 76, 204, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4500, 148, 36, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[4561, 152, 52, 1, 44, "Input"],
Cell[4616, 155, 1076, 17, 125, "Print",
 CellTags->"Info3591489692-4955531"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5741, 178, 47, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[5813, 182, 155, 4, 44, "Input"],
Cell[5971, 188, 1063, 30, 57, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7071, 223, 175, 5, 44, "Input"],
Cell[7249, 230, 540, 15, 52, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7838, 251, 42, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[7905, 255, 49, 1, 44, "Input"],
Cell[7957, 258, 464, 7, 75, "Print",
 CellTags->"Info3591489693-4955531"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8458, 270, 748, 22, 125, "Input"],
Cell[9209, 294, 215, 5, 30, "Output"]
}, Open  ]],
Cell[9439, 302, 33, 0, 28, "Text"],
Cell[9475, 304, 944, 28, 105, "Input"],
Cell[CellGroupData[{
Cell[10444, 336, 360, 11, 65, "Input"],
Cell[10807, 349, 210, 4, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11066, 359, 48, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[11139, 363, 50, 1, 44, "Input"],
Cell[11192, 366, 534, 10, 42, "Print",
 CellTags->"Info3591489696-7911430"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11763, 381, 545, 17, 155, "Input"],
Cell[12311, 400, 233, 5, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12593, 411, 34, 0, 31, "Subsection"],
Cell[12630, 413, 44, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[12699, 417, 157, 4, 44, "Input"],
Cell[12859, 423, 31707, 814, 458, "Output"]
}, Open  ]],
Cell[44581, 1240, 30, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[44636, 1244, 244, 8, 85, "Input"],
Cell[44883, 1254, 3076, 85, 157, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47996, 1344, 246, 8, 85, "Input"],
Cell[48245, 1354, 776, 21, 86, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49058, 1380, 275, 10, 44, "Input"],
Cell[49336, 1392, 465, 13, 49, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49850, 1411, 54, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[49929, 1415, 377, 11, 85, "Input"],
Cell[50309, 1428, 1177, 34, 53, "Output"]
}, Open  ]],
Cell[51501, 1465, 29, 0, 28, "Text"],
Cell[CellGroupData[{
Cell[51555, 1469, 882, 24, 153, "Input"],
Cell[52440, 1495, 238, 5, 30, "Output"]
}, Open  ]],
Cell[52693, 1503, 31, 0, 28, "Text"],
Cell[52727, 1505, 73, 2, 44, "Input"],
Cell[CellGroupData[{
Cell[52825, 1511, 972, 27, 153, "Input"],
Cell[53800, 1540, 237, 5, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[54086, 1551, 20, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[54131, 1555, 56, 1, 44, "Input"],
Cell[54190, 1558, 148, 2, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
