(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20720,        574]
NotebookOptionsPosition[     14115,        400]
NotebookOutlinePosition[     19454,        527]
CellTagsIndexPosition[     19369,        522]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["tensor symmetries", "Title",
 FontSize->18,
 FontColor->GrayLevel[0.5]],

Cell[CellGroupData[{

Cell["Initial section", "Section"],

Cell[CellGroupData[{

Cell["Package", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\n", "version"}], "Input"],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.5917998236137495`*^9, 3.5918230080804434`*^9, 
  3.591885929384182*^9, 3.5924628096053457`*^9, 3.592970691155531*^9, 
  3.594464268848116*^9, 3.594524883229904*^9, 3.602330768076145*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Wed 27 Nov 2013 08:04:23\"\>", ",", 
   "52831"}], "}"}]], "Output",
 CellChangeTimes->{3.5721064519095583`*^9, 3.572544134588682*^9, 
  3.5725468948045573`*^9, 3.5742001960107417`*^9, 3.5749572909386272`*^9, 
  3.577284402630447*^9, 3.5773448617476025`*^9, 3.581746516403935*^9, 
  3.586248823969959*^9, 3.5864139356818347`*^9, 3.5864144029338555`*^9, 
  3.5869896421820545`*^9, 3.5885724311526613`*^9, 3.590810632460479*^9, 
  3.59082424292542*^9, 3.590824279975485*^9, 3.5909017416121845`*^9, 
  3.590901772593839*^9, 3.5909097927263904`*^9, 3.5911982011624813`*^9, 
  3.5912251302874613`*^9, 3.591262610929158*^9, 3.5912667762144737`*^9, 
  3.59129128199454*^9, 3.5914824151704693`*^9, 3.591552153314273*^9, 
  3.591606040662755*^9, 3.5917998236137495`*^9, 3.5918230080960436`*^9, 
  3.591885929399782*^9, 3.592462809620946*^9, 3.5929706912465363`*^9, 
  3.5944642688561163`*^9, 3.594524883376912*^9, 3.6023307680861454`*^9}]
}, Open  ]],

Cell[TextData[{
 ButtonBox["Download ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
 StyleBox[ButtonBox["ccgrg",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.572524842630431*^9, 3.5725248687292767`*^9}},
 TextAlignment->Right]
}, Closed]],

Cell[CellGroupData[{

Cell["Coordinates and the metric tensor", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "metricSet"}]], "Input"],

Cell[BoxData[
 StyleBox["\<\"Schwarzschild, Friedman, LTB\"\>", "MSG"]], "Print", \
"PrintUsage",
 CellChangeTimes->{3.6023307683461456`*^9},
 CellTags->"Info3602334368-2045273"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["Friedman"], "Input"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "0", "0", "0"},
         {"0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0", "0"},
         {"0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0"},
         {"0", "0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.572106454296362*^9, 3.572544138870927*^9, 
  3.5725468982867565`*^9, 3.574200198678346*^9, 3.574957293855832*^9, 
  3.577284405688052*^9, 3.577344864836408*^9, 3.5817465193367405`*^9, 
  3.586248828696767*^9, 3.5864139394414415`*^9, 3.5864144063346615`*^9, 
  3.5869896455360603`*^9, 3.5885724342726665`*^9, 3.5908106362824855`*^9, 
  3.5908242464042253`*^9, 3.5908242836258907`*^9, 3.59090174481019*^9, 
  3.590901775823045*^9, 3.5909097960803967`*^9, 3.591198206279291*^9, 
  3.5912251324402647`*^9, 3.5912626164359674`*^9, 3.5912667812376823`*^9, 
  3.59129128765735*^9, 3.5914824172452726`*^9, 3.591552158259482*^9, 
  3.5916060426907587`*^9, 3.591799828883757*^9, 3.5918230130880527`*^9, 
  3.5918859343293905`*^9, 3.5924628149873557`*^9, 3.5929706978169117`*^9, 
  3.594464274058414*^9, 3.5945248885582085`*^9, 3.602330768866146*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Setting tensor symmetries", "Section"],

Cell[CellGroupData[{

Cell["The scheme of symmetry settings", "Subsection",
 CellChangeTimes->{{3.5908242898503017`*^9, 3.5908242908331037`*^9}, {
  3.5911982131277027`*^9, 3.591198213814104*^9}}],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"f", "[", "x_", "]"}], ":=", "x"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{"background", " ", "definition"}], " ", "*)"}], "\n", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"f", "[", "x_", "]"}], "/;", 
     RowBox[{"x", "<", "0"}]}], ":=", 
    RowBox[{"-", "x", " ", 
     RowBox[{"(*", " ", 
      RowBox[{"mask", " ", "definition"}], " ", "*)"}]}]}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}], ",", 
   RowBox[{"AspectRatio", "->", "Automatic"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF1fs313ccwPGvb7RvUXLNV3L7mrOUdHLSSHu/MWETRpicpbl0nLLwldL5
oplr5my5z+0cvq7fI5k5LnNq7/fmVhhdSd9GUQodc09OZts5L+/PD8/z+BOe
RoHhniF8Ho93+b/+N+7V8fn1dREF8YREe0n+XkRB7LZj9G3LOxEFsaF1xFr4
goiC+I/0LMGzCREFsWD/kD79U0RBnHPh9OffFokoiGsVoip4h0UUxEohTgeF
XxlTEGs87gyTZhpREHu2Fwbt6TGkIJb8fTTs2rgBBXHrpcKz9e76FMRuWd6G
/xToURA7ldxyc36jS0Fc1X15MMpfSEF8KilHa6BmJwVx/OlNN5Q1tCmIeeYG
xCFZk4L4yfcFqbWP1CmI9baGyhbt1SiIzx0yU5LrqVIQBx0eqWlvV6YgNoux
WT9fIaAgLvvLq+OynRIF8asELVsnHT4FcVvuR46vfdYIiA5MDi9alCwTEH3a
Jt+y5jNLQBQhq19R0xgnIDqw/Xyi/bMxAqI58b7tUXVjBERiW5noodMYAVH0
gNQtL/Y5AdHC1F6XQ32jBESbE1dKj4mHCYhSXaObq1WGCYgE2vO9gurHBERb
ZdPLPfIhAiLVgRFXd8dBAiKdXZ0rvjoPCIh8zojK7sfeISBKj4xKy2q6TUB0
K7Y93HOmm4DIJDvok/sBXQRE86Rcfs++nYBI39J5n1StjYAo2eX1qlFiKwHR
m4C0O2WLzQREbRm3z5QNNRIQ1fVl2tsdqSUgkry7N4r1awiIXEzV47BCJQFR
77pJ+JUfSgiIQv0qZfEn8gmIFBs/fBGnm0lAhIWuR1dpMgHR7E8FwXMFYgKi
WH5O57GP/Zj7C4O6Na2uMEeEDTPKqhlML8vHN1PscpjNw77fpUoKmdvotKjj
ZCkz8sy5yY6cKqbUeq9rZ4OM+VBl+kZn/3Vmsd8hm6CkBiaP17Qe9FsLs7tv
ON3S6zYzNOZJt//eO0yBiVwxaVMP8zPJ0/iHjb3Mvj2j4mjNAWaog7hOPnWf
GVZ6KXf39WGmjfnvv3jkjzP5F7WeBgtnmR+oeCQEziwzE58NOojL15g/F6V4
xM8r4A3DpcE7XvgoMU+dLdydmiBgXv3iorVlsTJTUTN34srqduZQb/Jskqoa
01sSaFXYrs4MU5427j+pyTSo7crbPKXFlLQ6eKkW7WRGVIU1W1kImSr8w4H7
X+oyHb85kWuWrcfU+XV3uKOJPjNLnJZ5YMiA6Znibl7SbMg080/yrogzYg5O
bJFmexsz+wNf2qkbiJjPFatXco05F6tC64WmnMLpaT0jc87gqPm3Fkc4VxPX
6477cppWCnWv/shp7SS/q5LN6TpZnHotjzPS3HApv4TzZpPp3apaTs8uy5SO
bs6Q0CVb517OmK0tC739nCVuNl8/eMT5ehDbjo1zrsbwF0JecW7b1SGbnOI8
GOC0c26O01FhS/+FJc4vy3uSVlY4zzpmHIl9z7nx3Q3/BQVWjYY=
     "]]}},
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  Method->{},
  PlotRange->{{-10, 10}, {0., 9.999999591836735}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.5721064551231637`*^9, 3.5725441394549603`*^9, 
  3.5725468988077865`*^9, 3.5742001994583473`*^9, 3.5749572943862333`*^9, 
  3.577284406171653*^9, 3.5773448655228095`*^9, 3.581746520288342*^9, 
  3.5862488294923687`*^9, 3.5864139403774433`*^9, 3.586414406818262*^9, 
  3.586989646503262*^9, 3.5885724348966675`*^9, 3.5908106369220867`*^9, 
  3.590824246903426*^9, 3.5908242842654924`*^9, 3.590901745746192*^9, 
  3.590901776275446*^9, 3.5909097971099977`*^9, 3.591198206996892*^9, 
  3.591225133189066*^9, 3.591262617278369*^9, 3.5912667819708843`*^9, 
  3.591291288936552*^9, 3.5914824181968746`*^9, 3.5915521595386844`*^9, 
  3.59160604350196*^9, 3.5917998299137583`*^9, 3.591823013868054*^9, 
  3.591885935546193*^9, 3.592462815704957*^9, 3.592970699907031*^9, 
  3.594464274838459*^9, 3.5945248895482655`*^9, 3.602330769066147*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example: symmetrization of Riemann tensor", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"Rcov", ",", "R"}], "]"}], ";"}]], "Input"],

Cell["Background definition:", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"erasable", "[", "Rcov", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Rcov", "[", 
    RowBox[{"i_", ",", "j_", ",", "m_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Rcov", "[", 
     RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}], "=", "\n", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"x\[DoubleDagger]", "[", 
        RowBox[{"-", "n"}], "]"}]], 
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"i", ",", "m", ",", "j"}], "]"}]}], "-", 
     RowBox[{
      SubscriptBox["\[PartialD]", 
       RowBox[{"x\[DoubleDagger]", "[", 
        RowBox[{"-", "m"}], "]"}]], 
      RowBox[{"\[CapitalGamma]", "[", 
       RowBox[{"i", ",", "n", ",", "j"}], "]"}]}], "+", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"p", "=", "1"}], "dim"], 
      RowBox[{
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{
         RowBox[{"-", "p"}], ",", "i", ",", "n"}], "]"}], " ", 
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{"p", ",", "j", ",", "m"}], "]"}]}]}], "-", 
     RowBox[{
      UnderoverscriptBox["\[Sum]", 
       RowBox[{"p", "=", "1"}], "dim"], 
      RowBox[{
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{
         RowBox[{"-", "p"}], ",", "i", ",", "m"}], "]"}], " ", 
       RowBox[{"\[CapitalGamma]", "[", 
        RowBox[{"p", ",", "j", ",", "n"}], "]"}]}]}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{3.5736637236143537`*^9, 3.5741997842452197`*^9}],

Cell["Mask definitions: ", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Rcov", "[", 
     RowBox[{"j_", ",", "i_", ",", "m_", ",", "n_"}], "]"}], "/;", 
    RowBox[{"i", "<", "j"}]}], ":=", 
   RowBox[{"-", 
    RowBox[{"Rcov", "[", 
     RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}]}]}], ";", 
  RowBox[{
   RowBox[{
    RowBox[{"Rcov", "[", 
     RowBox[{"i_", ",", "j_", ",", "n_", ",", "m_"}], "]"}], "/;", 
    RowBox[{"m", "<", "n"}]}], ":=", 
   RowBox[{"-", 
    RowBox[{"Rcov", "[", 
     RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}]}]}], ";", 
  RowBox[{
   RowBox[{
    RowBox[{"Rcov", "[", 
     RowBox[{"m_", ",", "n_", ",", "i_", ",", "j_"}], "]"}], "/;", 
    RowBox[{
     RowBox[{"i", "+", "j"}], "<", 
     RowBox[{"m", "+", "n"}]}]}], ":=", 
   RowBox[{"Rcov", "[", 
    RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.586042859640256*^9, 3.586042877580287*^9}, {
  3.596116972833684*^9, 3.596116982672247*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Extension to contravariant and mixed", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"erasable", "[", "R", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"R", "[", 
    RowBox[{"i_", ",", "j_", ",", "m_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"R", "[", 
     RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}], "=", 
    RowBox[{
     RowBox[{"tensorExt", "[", "Rcov", "]"}], "[", 
     RowBox[{"i", ",", "j", ",", "m", ",", "n"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{3.5736637245035553`*^9, 3.57419979037603*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {3.5689765261927013`*^9}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {3.568976573569985*^9}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {3.5689765583287582`*^9}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {3.568981227090465*^9}, FontFamily -> "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {3.5689812390088863`*^9}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", CellChangeTimes -> {3.568980449396245*^9}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3602334368-2045273"->{
  Cell[3148, 99, 178, 4, 70, "Print",
   CellTags->"Info3602334368-2045273"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3602334368-2045273", 19267, 516}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 77, 2, 69, "Title"],
Cell[CellGroupData[{
Cell[682, 28, 34, 0, 46, "Section"],
Cell[CellGroupData[{
Cell[741, 32, 29, 0, 31, "Subsection"],
Cell[CellGroupData[{
Cell[795, 36, 111, 3, 65, "Input"],
Cell[909, 41, 399, 8, 70, "Print"],
Cell[1311, 51, 998, 15, 70, "Output"]
}, Open  ]],
Cell[2324, 69, 652, 18, 28, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[3013, 92, 55, 0, 25, "Subsection"],
Cell[CellGroupData[{
Cell[3093, 96, 52, 1, 44, "Input"],
Cell[3148, 99, 178, 4, 70, "Print",
 CellTags->"Info3602334368-2045273"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3363, 108, 34, 0, 44, "Input"],
Cell[3400, 110, 3593, 87, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[7054, 204, 44, 0, 38, "Section"],
Cell[CellGroupData[{
Cell[7123, 208, 174, 2, 31, "Subsection"],
Cell[7300, 212, 435, 13, 65, "Input"],
Cell[CellGroupData[{
Cell[7760, 229, 244, 7, 44, "Input"],
Cell[8007, 238, 2700, 49, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[10756, 293, 63, 0, 25, "Subsection"],
Cell[10822, 295, 103, 3, 44, "Input"],
Cell[10928, 300, 38, 0, 28, "Text"],
Cell[10969, 302, 1499, 41, 112, "Input"],
Cell[12471, 345, 34, 0, 28, "Text"],
Cell[12508, 347, 975, 28, 65, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13520, 380, 58, 0, 31, "Subsection"],
Cell[13581, 382, 494, 13, 65, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
