(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15733,        434]
NotebookOptionsPosition[      9018,        261]
NotebookOutlinePosition[     14735,        396]
CellTagsIndexPosition[     14650,        391]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["", "Title",
 CellChangeTimes->{{3.570062749816049*^9, 3.570062758630065*^9}, {
   3.5747384883425665`*^9, 3.5747385043554826`*^9}, 3.5747386347059383`*^9}],

Cell[CellGroupData[{

Cell["Packages", "Subsubsection",
 CellChangeTimes->{3.59127031011714*^9, 3.5944244563872695`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Needs", "[", "\"\<ccgrg`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", "version"}], "Input",
 CellChangeTimes->{{3.569248318616022*^9, 3.569248324528433*^9}, {
   3.5692484074737787`*^9, 3.569248410578184*^9}, 3.5692565693737264`*^9, {
   3.569256610885399*^9, 3.5692566149570065`*^9}, 3.569256693846345*^9, {
   3.5692568610318384`*^9, 3.5692568681298513`*^9}, {3.569270782371048*^9, 
   3.569270785069853*^9}, 3.5692742450656404`*^9, 3.5692743590862412`*^9, 
   3.59127031011714*^9}],

Cell[BoxData[
 StyleBox["\<\"ccgrg - Copernicus Center General Relativity Package for \
Mathematica 8/9\"\>",
  StripOnInput->False,
  FontFamily->"Helvetica",
  FontSlant->Italic]], "Print",
 CellChangeTimes->{3.5944281510725937`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"ver-1.04\"\>", ",", "\<\"Tue 26 Nov 2013 04:26:23\"\>", ",", 
   "51157"}], "}"}]], "Output",
 CellChangeTimes->{{3.594424367391179*^9, 3.5944243921105933`*^9}, 
   3.59442539613302*^9, 3.5944275912865753`*^9, 3.5944277069281898`*^9, 
   3.594427888626582*^9, 3.594427932378085*^9, 3.594428040062244*^9, {
   3.594428077702397*^9, 3.5944280983935804`*^9}, 3.5944281512246017`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<OTW`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.435250828484375*^9, 3.435250839609375*^9}, {
  3.435252796015625*^9, 3.435252801765625*^9}, {3.43525322684375*^9, 
  3.435253228640625*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"OTW functions are: IMetric, Christoffel, ChristoffelFull\\n \
 Riemann, RiemannFull, Ricci, RicciFull, SCurvature, EinsteinTensor, \
EinsteinFull,\\n SqRicci, SqRiemann, Geodesics, FullReport.\\n For input use \
the metric (matrix form) and coordinates (list form). \"\>"], "Print",
 CellChangeTimes->{3.594428152081651*^9}],

Cell[BoxData["\<\"Enter 'helpOTW' for the list of functions\"\>"], "Print",
 CellChangeTimes->{3.5944281520906515`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Metric", "Subsubsection",
 CellChangeTimes->{{3.5944244592704344`*^9, 3.594424470874098*^9}}],

Cell[CellGroupData[{

Cell[BoxData["Friedman"], "Input",
 CellChangeTimes->{{3.5944244730672235`*^9, 3.5944244832998085`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"new metric:  \"\>"},
    {"\<\"  \"\>"},
    {
     TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
         {
          RowBox[{"-", 
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"]}], "0", "0", "0"},
         {"0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0", "0"},
         {"0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]],
           "0"},
         {"0", "0", "0", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"a", "[", "\[Eta]", "]"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{
               FractionBox["1", "4"], " ", "K", " ", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["\[ScriptX]", "2"], "+", 
                 SuperscriptBox["\[ScriptY]", "2"], "+", 
                 SuperscriptBox["\[ScriptZ]", "2"]}], ")"}]}]}], ")"}], "2"]]}
        },
        GridBoxAlignment->{
         "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.7]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
      Function[BoxForm`e$, 
       MatrixForm[BoxForm`e$]]]},
    {"\<\" \"\>"},
    {
     RowBox[{"\<\"simplification method: \"\>", " ", "Together"}]}
   },
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.5944244869020147`*^9, 3.5944254003072586`*^9, 3.59442759538481*^9, 
   3.5944277126195154`*^9, 3.594427892683814*^9, 3.594427937819396*^9, 
   3.594428044925522*^9, {3.5944280796015053`*^9, 3.594428100196684*^9}, 
   3.594428155282834*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"var", "=", "x"}], ";"}]], "Input",
 CellChangeTimes->{{3.5944244980546527`*^9, 3.5944244994567327`*^9}, {
   3.5944254080617023`*^9, 3.5944254093947783`*^9}, 3.5944280183380013`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "Ricci"}]], "Input",
 CellChangeTimes->{{3.594427603278261*^9, 3.594427637573223*^9}}],

Cell[BoxData[
 StyleBox["\<\"Ricci[g,x], with g a n.n-matrix and x n-vector of\\n  \
coordinates, gives the Ricci tensor (two lower symmetric indices).\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.594428157498961*^9},
 CellTags->"Info3594431757-5545529"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Ricci", "[", 
    RowBox[{"g", ",", "var"}], "]"}], ";"}], "//", 
  "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Outer", "[", 
    RowBox[{"Ric", ",", "all", ",", "all"}], "]"}], ";"}], "//", 
  "Timing"}]}], "Input",
 CellChangeTimes->{{3.5944276643237534`*^9, 3.5944276853759575`*^9}, {
   3.5944279869692073`*^9, 3.594428003903176*^9}, 3.5944280745492163`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4679999999999999`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.594427674885357*^9, 3.594427715181662*^9}, {
   3.5944277484155626`*^9, 3.5944277521947784`*^9}, 3.594427897036063*^9, 
   3.5944279405045495`*^9, 3.5944280487237396`*^9, {3.594428080663566*^9, 
   3.5944281010767336`*^9}, 3.59442815853202*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3740000000000004`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.594427674885357*^9, 3.594427715181662*^9}, {
   3.5944277484155626`*^9, 3.5944277521947784`*^9}, 3.594427897036063*^9, 
   3.5944279405045495`*^9, 3.5944280487237396`*^9, {3.594428080663566*^9, 
   3.5944281010767336`*^9}, 3.594428158908042*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Riemann", "[", 
    RowBox[{"g", ",", "var"}], "]"}], ";"}], "//", "Timing"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Outer", "[", 
    RowBox[{"Riem", ",", "all", ",", "all", ",", "all", ",", "all"}], "]"}], 
   ";"}], "//", "Timing"}]}], "Input",
 CellChangeTimes->{{3.5944277353858175`*^9, 3.594427739668062*^9}, 
   3.5944278124832273`*^9, 3.5944279643999166`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.12400000000000001`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.5944278615690346`*^9, 3.5944278976470985`*^9}, 
   3.5944279409635763`*^9, 3.5944280496147904`*^9, {3.594428080990585*^9, 
   3.594428101291746*^9}, 3.5944281593840685`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.03200000000000012`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.5944278615690346`*^9, 3.5944278976470985`*^9}, 
   3.5944279409635763`*^9, 3.5944280496147904`*^9, {3.594428080990585*^9, 
   3.594428101291746*^9}, 3.5944281594620733`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{
  Scaled[
   Rational[3, 4]], 
  Scaled[1]},
WindowMargins->{{65, Automatic}, {Automatic, 3}},
WindowFrame->"Generic",
ShowSelection->True,
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (October 6, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {{3.568976128298403*^9, 3.568976151589244*^9}, {
        3.5689765242894983`*^9, 3.5689765261927013`*^9}}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {{3.56897650241826*^9, 3.5689765210758924`*^9}, {
           3.568976571417181*^9, 3.568976573569985*^9}}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {{3.568976536114319*^9, 
           3.5689765583287582`*^9}}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {{3.568976333111162*^9, 3.5689763428923798`*^9}, {
        3.5689812244072604`*^9, 3.568981227090465*^9}}, FontFamily -> 
       "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {{3.5689812314740725`*^9, 
           3.5689812390088863`*^9}}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", 
          CellChangeTimes -> {{3.568980449396245*^9, 
           3.5689804565254574`*^9}}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "8.0 for Microsoft Windows (32-bit) (October 6, 2011)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3594431757-5545529"->{
  Cell[6464, 188, 271, 5, 58, "Print",
   CellTags->"Info3594431757-5545529"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3594431757-5545529", 14547, 385}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 161, 2, 76, "Title"],
Cell[CellGroupData[{
Cell[766, 28, 98, 1, 29, "Subsubsection"],
Cell[CellGroupData[{
Cell[889, 33, 521, 9, 65, "Input"],
Cell[1413, 44, 235, 6, 23, "Print"],
Cell[1651, 52, 424, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2112, 64, 232, 4, 44, "Input"],
Cell[CellGroupData[{
Cell[2369, 72, 342, 4, 81, "Print"],
Cell[2714, 78, 119, 1, 23, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2894, 86, 99, 1, 29, "Subsubsection"],
Cell[CellGroupData[{
Cell[3018, 91, 104, 1, 44, "Input"],
Cell[3125, 94, 2965, 79, 204, "Output"]
}, Open  ]],
Cell[6105, 176, 217, 4, 44, "Input"],
Cell[CellGroupData[{
Cell[6347, 184, 114, 2, 44, "Input"],
Cell[6464, 188, 271, 5, 58, "Print",
 CellTags->"Info3594431757-5545529"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6772, 198, 435, 12, 65, "Input"],
Cell[7210, 212, 361, 6, 30, "Output"],
Cell[7574, 220, 362, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7973, 231, 417, 11, 65, "Input"],
Cell[8393, 244, 291, 5, 30, "Output"],
Cell[8687, 251, 291, 5, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
