(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     36128,       1013]
NotebookOptionsPosition[     29131,        840]
NotebookOutlinePosition[     34641,        965]
CellTagsIndexPosition[     34598,        962]
WindowFrame->Generic*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 StyleBox["ccgrg",
  FontSlant->"Italic"],
 " assistant"
}], "Title",
 CellChangeTimes->{{3.5658804007366376`*^9, 3.565880428270686*^9}, {
  3.5658891385299463`*^9, 3.5658891476091623`*^9}},
 TextAlignment->Right,
 FontSize->16],

Cell[CellGroupData[{

Cell["About", "Subsection",
 CellChangeTimes->{{3.5660721836835885`*^9, 3.5660721974272127`*^9}, {
  3.5730676114111605`*^9, 3.573067613875965*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"ccgrg objectives\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"ccgrg objectives\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "introduction.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089298823267*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"developed by\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"developed by\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "_developed.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089298823267*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Installation", "Subsection",
 CellChangeTimes->{{3.5660707967039523`*^9, 3.566070802288762*^9}, {
   3.5660708869781113`*^9, 3.566070890207317*^9}, {3.566098649601127*^9, 
   3.566098658571143*^9}, 3.566117766729603*^9}],

Cell[TextData[{
 ButtonBox["Download ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
 StyleBox[ButtonBox["ccgrg",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.\
zip"], None},
  ButtonNote->
   "http://mth.drac.oa.uj.edu.pl/mufiles/00002/ccgrg/package/ccgrg_pack.zip"],
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.572524842630431*^9, 3.5725248687292767`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Read and install\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Read and install\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "install.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089290874812*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["How to begin?", "Subsection",
 CellChangeTimes->{{3.565689777938896*^9, 3.5656897800604997`*^9}, {
   3.5656898730054626`*^9, 3.5656899147199364`*^9}, {3.565880392905424*^9, 
   3.5658803944654264`*^9}, {3.5660986969784107`*^9, 3.5660987011280174`*^9}, 
   3.566105297832672*^9, {3.5661178162128897`*^9, 3.5661178195824957`*^9}, {
   3.574583093024391*^9, 3.5745831003720045`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"First steps\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"First steps\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "firstSteps.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 
   3.5692480080662766`*^9}}]], "Text",
 CellChangeTimes->{{3.5692477099497533`*^9, 3.5692477207917724`*^9}, 
   3.569248053181556*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Description", "Subsection",
 CellChangeTimes->{{3.565689777938896*^9, 3.5656897800604997`*^9}, {
   3.5656898730054626`*^9, 3.5656899147199364`*^9}, {3.565880392905424*^9, 
   3.5658803944654264`*^9}, {3.5660986969784107`*^9, 3.5660987011280174`*^9}, 
   3.566105297832672*^9, {3.5661178162128897`*^9, 3.5661178195824957`*^9}, {
   3.574583093024391*^9, 3.5745831003720045`*^9}, {3.57473822126029*^9, 
   3.5747382248124933`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Conventions\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Conventions\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "conventions.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, {
  3.569089145601503*^9, 3.5690891489796963`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"List of functions\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"List of functions\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "usage.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690891778983507`*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Opening procedure\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Opening procedure\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "opening.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690891914161234`*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Tensor, vector, scalar\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Tensor, vector, scalar\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "tensordefinition.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690892027677727`*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Tensor symmetries\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Tensor symmetries\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "tensorsymm.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690892126233363`*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Metrics and curvature\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Metrics and curvature\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "curvature.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692295863593616`*^9, {3.569229668009905*^9, 
   3.56922971064478*^9}}]], "Text",
 CellChangeTimes->{{3.5692297476480455`*^9, 3.5692297593636656`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Covariant derivative\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Covariant derivative\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "covariantD.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089224362008*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Vector fields and hypersurfaces\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Vector fields and hypersurfaces\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "hypersurfaces.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089248680399*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Perturbations\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Perturbations\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "perturbations.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692295863593616`*^9, {3.569229668009905*^9, 
   3.56922971064478*^9}}]], "Text",
 CellChangeTimes->{{3.5692297476480455`*^9, 3.5692297593636656`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Memory content", "Subsection",
 CellChangeTimes->{{3.5691325553740416`*^9, 3.5691325666372614`*^9}, 
   3.569142831046521*^9, {3.5696442540882006`*^9, 3.5696442573018064`*^9}, {
   3.570869614817915*^9, 3.570869619747524*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"View and clear\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"View and clear\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "memory.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 3.5692480080662766`*^9}, 
   3.5692481204644747`*^9, 3.569419246593629*^9, 3.5694197063835516`*^9, 
   3.5696557582133904`*^9, 3.5696558579443655`*^9, 3.569656298364339*^9, 
   3.569656358003244*^9, 3.5696566866958213`*^9, 
   3.569657140937419*^9}]], "Text",
 CellChangeTimes->{{3.5696571692358685`*^9, 3.569657179329087*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Advanced examples", "Subsection",
 CellChangeTimes->{{3.5684938058908653`*^9, 3.5684938254220996`*^9}, {
  3.5720925248027935`*^9, 3.572092527626398*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Curvature invariants\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Curvature invariants\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>Module[{}, $CellContext`stan = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "advanced", "CM_invariants.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.569089646909176*^9, 3.569090444620803*^9, 3.56909055052786*^9, {
   3.569096570341525*^9, 3.5690965829502463`*^9}, 3.569096636581314*^9, 
   3.5690966696992083`*^9, 3.569419250665236*^9}]], "Text",
 CellChangeTimes->{{3.5694192647052608`*^9, 3.5694192749856787`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Killing vectors and Lie derivatives\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Killing vectors and Lie derivatives\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$, $CellContext`fullname$}, $CellContext`stan$ = {
      WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname$ = FileNameJoin[{
        NotebookDirectory[], "_files", "killing&lie.nb"}]; 
    NotebookOpen[$CellContext`fullname$, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690888125894556`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690892767880063`*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Geodesic equation\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Geodesic equation\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>Module[{}, $CellContext`stan = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "advanced", "geodesic.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan]]],
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{3.569419250665236*^9, 3.569419710283559*^9}]], "Text",
 CellChangeTimes->{3.570042790819371*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Geodesic lines on 2D surfaces\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Geodesic lines on 2D surfaces\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "advanced", "2d surfaces.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 
   3.5692480080662766`*^9}}]], "Text",
 CellChangeTimes->{{3.5692477099497533`*^9, 3.5692477207917724`*^9}, 
   3.569248053181556*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Stellar structure\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Stellar structure\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>Module[{}, $CellContext`stan = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "advanced", "oppenheimer.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690917119692907`*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.569089690349661*^9, 3.569091745954235*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Cosmological perturbations\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Cosmological perturbations\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>Module[{}, $CellContext`stan = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "advanced", "RWpert1.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{3.5690917119692907`*^9, 3.569091846276973*^9}]], "Text",
 CellChangeTimes->{{3.569089064867885*^9, 3.569089069781166*^9}, 
   3.5690896764878683`*^9, 3.5690918588216906`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Reliability", "Subsection",
 CellChangeTimes->{{3.572091511128613*^9, 3.5720915249970374`*^9}, {
  3.57209694465499*^9, 3.572096974872243*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Basic test\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Basic test\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "tests", "Basic test.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 
   3.5692480080662766`*^9}}]], "Text",
 CellChangeTimes->{{3.5692477099497533`*^9, 3.5692477207917724`*^9}, 
   3.569248053181556*^9}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Advanced test\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Advanced test\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "tests", "Advanced test.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 
   3.5692480080662766`*^9}}]], "Text",
 CellChangeTimes->{{3.5692477099497533`*^9, 3.5692477207917724`*^9}, 
   3.569248053181556*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["New session", "Subsection",
 CellChangeTimes->{{3.569247688000515*^9, 3.569247701026538*^9}, {
  3.571030320607108*^9, 3.5710303227479134`*^9}, {3.574582781335844*^9, 
  3.5745828065766883`*^9}, {3.5761266716633563`*^9, 3.5761266748769617`*^9}}],

Cell[TextData[Cell[BoxData[
 ButtonBox[
  PaneSelectorBox[{False->
   StyleBox["\<\"Blank page\"\>", "Hyperlink",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12], True->
   StyleBox["\<\"Blank page\"\>", "HyperlinkActive",
    StripOnInput->False,
    FontFamily->"Candara",
    FontSize->12]}, Dynamic[
    CurrentValue["MouseOver"]],
   FrameMargins->0,
   ImageSize->Automatic],
  Appearance->None,
  ButtonFunction:>
   Module[{$CellContext`stan$}, $CellContext`stan$ = {WindowSize -> {
         Scaled[3/4], 
         Scaled[1]}, 
       WindowMargins -> {{Automatic, 0}, {
         Automatic, 0}}}; $CellContext`fullname = FileNameJoin[{
        NotebookDirectory[], "_files", "_startPage.nb"}]; 
    NotebookOpen[$CellContext`fullname, 
      Apply[Sequence, $CellContext`stan$]]],
  Evaluator->Automatic,
  Method->"Preemptive"]],
 CellChangeTimes->{
  3.5690888125894556`*^9, 3.569091429529136*^9, 3.5690966615397415`*^9, 
   3.5692478405999827`*^9, {3.569247983293433*^9, 
   3.5692480080662766`*^9}}]], "Text",
 CellChangeTimes->{{3.5692477099497533`*^9, 3.5692477207917724`*^9}, 
   3.569248053181556*^9}]
}, Closed]]
}, Open  ]]
},
WindowSize->{316, 630},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowFrame->"Generic",
FrontEndVersion->"9.0 for Microsoft Windows (32-bit) (January 25, 2013)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    CellGroupData[{
      Cell[
      "Background colors", "Subsection", 
       CellChangeTimes -> {{3.568976128298403*^9, 3.568976151589244*^9}, {
        3.5689765242894983`*^9, 3.5689765261927013`*^9}}], 
      Cell[
       CellGroupData[{
         Cell[
         "Background", "Subsubsection", 
          CellChangeTimes -> {{3.56897650241826*^9, 3.5689765210758924`*^9}, {
           3.568976571417181*^9, 3.568976573569985*^9}}], 
         Cell[
          StyleData[All, "Working"], PageWidth -> WindowWidth, 
          CellBracketOptions -> {"Color" -> GrayLevel[0]}, 
          CellLabelMargins -> {{12, Inherited}, {Inherited, Inherited}}, 
          ScriptMinSize -> 9, Background -> GrayLevel[0.94902]]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Background for input cell", "Subsubsection", 
          CellChangeTimes -> {{3.568976536114319*^9, 
           3.5689765583287582`*^9}}], 
         Cell[
          StyleData["Input"], CellMargins -> {{66, 10}, {5, 7}}, Evaluatable -> 
          True, CellGroupingRules -> "InputGrouping", CellHorizontalScrolling -> 
          True, PageBreakWithin -> False, GroupPageBreakWithin -> False, 
          DefaultFormatType -> DefaultInputFormatType, 
          "TwoByteSyntaxCharacterAutoReplacement" -> True, 
          HyphenationOptions -> {"HyphenationCharacter" -> "\[Continuation]"},
           AutoItalicWords -> {}, LanguageCategory -> "Mathematica", 
          FormatType -> InputForm, ShowStringCharacters -> True, NumberMarks -> 
          True, LinebreakAdjustments -> {0.85, 2, 10, 0, 1}, 
          CounterIncrements -> "Input", FontFamily -> "Helvetica", FontSize -> 
          12, FontWeight -> "Bold", Background -> 
          RGBColor[
           0.8941176470588236, 0.8941176470588236, 0.8941176470588236]]}, 
        Closed]]}, Closed]], 
   Cell[
    CellGroupData[{
      Cell[
      "Headings and text", "Subsection", 
       CellChangeTimes -> {{3.568976333111162*^9, 3.5689763428923798`*^9}, {
        3.5689812244072604`*^9, 3.568981227090465*^9}}, FontFamily -> 
       "Candara"], 
      Cell[
       CellGroupData[{
         Cell[
         "Headings", "Subsubsection", 
          CellChangeTimes -> {{3.5689812314740725`*^9, 
           3.5689812390088863`*^9}}], 
         Cell[
          StyleData["Title"], CellFrame -> {{0, 0}, {1, 0}}, CellDingbat -> 
          None, CellMargins -> {{27, Inherited}, {8, 34}}, 
          CellGroupingRules -> {"TitleGrouping", 0}, PageBreakBelow -> False, 
          CellFrameMargins -> 4, CellFrameColor -> 
          RGBColor[1, 0.611765, 0.317647], DefaultNewInlineCellStyle -> 
          "None", LineSpacing -> {1, 2}, FontFamily -> "Candara", FontSize -> 
          24, FontWeight -> "Plain"], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Section"], CellFrame -> {{0, 0}, {0.5, 0}}, 
             ShowGroupOpener -> True, 
             CellMargins -> {{60, Inherited}, {8, 12}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 18, FontWeight -> "Plain", FontSlant -> 
             "Plain", FontTracking -> "Plain", 
             FontVariations -> {
              "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
               "StrikeThrough" -> False, "Underline" -> False}], 
            Cell[
             BoxData[" "], "Input", CellFrame -> {{0, 0}, {0.5, 0}}, 
             CellChangeTimes -> {3.5689766331932898`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          CellGroupData[{
            Cell[
             StyleData["Subsection"], CellDingbat -> None, ShowGroupOpener -> 
             True, CellMargins -> {{60, Inherited}, {2, 10}}, PageBreakBelow -> 
             False, DefaultNewInlineCellStyle -> "None", FontFamily -> 
             "Candara", FontSize -> 16, FontWeight -> "Plain"], 
            Cell[
             BoxData[" "], "Input", 
             CellChangeTimes -> {3.5689772404087563`*^9}, FontFamily -> 
             "Candara"]}, Open]], 
         Cell[
          StyleData["Subsubsection"], CellDingbat -> None, ShowGroupOpener -> 
          True, FontFamily -> "Candara", FontSize -> 14, FontWeight -> 
          "Plain", FontSlant -> "Plain", FontTracking -> "Plain", 
          FontVariations -> {
           "Masked" -> False, "Outline" -> False, "Shadow" -> False, 
            "StrikeThrough" -> False, "Underline" -> False}]}, Closed]], 
      Cell[
       CellGroupData[{
         Cell[
         "Text", "Subsubsection", 
          CellChangeTimes -> {{3.568980449396245*^9, 
           3.5689804565254574`*^9}}], 
         Cell[
          StyleData["Text"], FontFamily -> "Candara", FontSize -> 12, 
          FontWeight -> "Plain", FontSlant -> "Plain", 
          FontVariations -> {
           "StrikeThrough" -> False, "Underline" -> False}]}, Closed]]}, 
     Open]]}, Visible -> False, FrontEndVersion -> 
  "9.0 for Microsoft Windows (32-bit) (January 25, 2013)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 244, 8, 66, "Title"],
Cell[CellGroupData[{
Cell[849, 34, 148, 2, 31, "Subsection"],
Cell[1000, 38, 1053, 29, 29, "Text"],
Cell[2056, 69, 1043, 29, 29, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3136, 103, 226, 3, 31, "Subsection"],
Cell[3365, 108, 629, 17, 28, "Text"],
Cell[3997, 127, 1048, 29, 31, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[5082, 161, 387, 5, 25, "Subsection"],
Cell[5472, 168, 1141, 31, 31, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[6650, 204, 436, 6, 25, "Subsection"],
Cell[7089, 212, 1067, 29, 31, "Text"],
Cell[8159, 243, 1050, 29, 31, "Text"],
Cell[9212, 274, 1052, 29, 31, "Text"],
Cell[10267, 305, 1071, 29, 31, "Text"],
Cell[11341, 336, 1055, 29, 31, "Text"],
Cell[12399, 367, 1141, 30, 31, "Text"],
Cell[13543, 399, 1059, 29, 31, "Text"],
Cell[14605, 430, 1084, 29, 49, "Text"],
Cell[15692, 461, 1129, 30, 31, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[16858, 496, 232, 3, 25, "Subsection"],
Cell[17093, 501, 1335, 33, 31, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[18465, 539, 160, 2, 25, "Subsection"],
Cell[18628, 543, 1163, 29, 31, "Text"],
Cell[19794, 574, 1092, 29, 49, "Text"],
Cell[20889, 605, 986, 26, 31, "Text"],
Cell[21878, 633, 1190, 31, 49, "Text"],
Cell[23071, 666, 1031, 27, 31, "Text"],
Cell[24105, 695, 1071, 27, 49, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[25213, 727, 149, 2, 25, "Subsection"],
Cell[25365, 731, 1148, 31, 31, "Text"],
Cell[26516, 764, 1157, 31, 31, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[27710, 800, 251, 3, 25, "Subsection"],
Cell[27964, 805, 1139, 31, 31, "Text"]
}, Closed]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
